# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class ArchivalQstarTapeExternalTargetParams(BaseModel):
    """
    Specifies the parameters which are specific to QStar Tape related External Targets of archival purpose type.
    """ # noqa: E501
    host: Optional[StrictStr] = Field(description="Specifies the host of the QStar Tape external target.")
    integral_volume_names: Optional[List[StrictStr]] = Field(default=None, description="Specifies the Integral Volume Names of the QStar Tape external target.", alias="integralVolumeNames")
    is_forever_incremental_archival_enabled: Optional[StrictBool] = Field(default=None, description="Specifies if Forever Incremental Archival setting is enabled or not.", alias="isForeverIncrementalArchivalEnabled")
    is_incremental_archival_enabled: Optional[StrictBool] = Field(default=None, description="Specifies if Incremental Archival setting is enabled or not.", alias="isIncrementalArchivalEnabled")
    password: Optional[StrictStr] = Field(default=None, description="Specifies the Password of the QStar Tape external target.")
    share_type: Optional[StrictStr] = Field(default=None, description="Specifies the share type of QStar Tape external target.", alias="shareType")
    use_https: Optional[StrictBool] = Field(default=None, description="Specifies whether HTTPS is used or not.", alias="useHttps")
    username: Optional[StrictStr] = Field(description="Specifies the Username of the QStar Tape external target.")
    web_services_port: Optional[StrictInt] = Field(description="Specifies the Web Services Port of the QStar Tape external target.", alias="webServicesPort")
    __properties: ClassVar[List[str]] = ["host", "integralVolumeNames", "isForeverIncrementalArchivalEnabled", "isIncrementalArchivalEnabled", "password", "shareType", "useHttps", "username", "webServicesPort"]

    @field_validator('share_type')
    def share_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['CIFS', 'NFS']):
            raise ValueError("must be one of enum values ('CIFS', 'NFS')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ArchivalQstarTapeExternalTargetParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if host (nullable) is None
        # and model_fields_set contains the field
        if self.host is None and "host" in self.model_fields_set:
            _dict['host'] = None

        # set to None if integral_volume_names (nullable) is None
        # and model_fields_set contains the field
        if self.integral_volume_names is None and "integral_volume_names" in self.model_fields_set:
            _dict['integralVolumeNames'] = None

        # set to None if is_forever_incremental_archival_enabled (nullable) is None
        # and model_fields_set contains the field
        if self.is_forever_incremental_archival_enabled is None and "is_forever_incremental_archival_enabled" in self.model_fields_set:
            _dict['isForeverIncrementalArchivalEnabled'] = None

        # set to None if is_incremental_archival_enabled (nullable) is None
        # and model_fields_set contains the field
        if self.is_incremental_archival_enabled is None and "is_incremental_archival_enabled" in self.model_fields_set:
            _dict['isIncrementalArchivalEnabled'] = None

        # set to None if password (nullable) is None
        # and model_fields_set contains the field
        if self.password is None and "password" in self.model_fields_set:
            _dict['password'] = None

        # set to None if share_type (nullable) is None
        # and model_fields_set contains the field
        if self.share_type is None and "share_type" in self.model_fields_set:
            _dict['shareType'] = None

        # set to None if use_https (nullable) is None
        # and model_fields_set contains the field
        if self.use_https is None and "use_https" in self.model_fields_set:
            _dict['useHttps'] = None

        # set to None if username (nullable) is None
        # and model_fields_set contains the field
        if self.username is None and "username" in self.model_fields_set:
            _dict['username'] = None

        # set to None if web_services_port (nullable) is None
        # and model_fields_set contains the field
        if self.web_services_port is None and "web_services_port" in self.model_fields_set:
            _dict['webServicesPort'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ArchivalQstarTapeExternalTargetParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "host": obj.get("host"),
            "integralVolumeNames": obj.get("integralVolumeNames"),
            "isForeverIncrementalArchivalEnabled": obj.get("isForeverIncrementalArchivalEnabled"),
            "isIncrementalArchivalEnabled": obj.get("isIncrementalArchivalEnabled"),
            "password": obj.get("password"),
            "shareType": obj.get("shareType"),
            "useHttps": obj.get("useHttps"),
            "username": obj.get("username"),
            "webServicesPort": obj.get("webServicesPort")
        })
        return _obj


