# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.fixed_issue import FixedIssue
from typing import Set
from typing_extensions import Self

class AvailablePatch(BaseModel):
    """
    Specifies the description of an available patch.
    """ # noqa: E501
    component: Optional[StrictStr] = Field(default=None, description="Specifies the description of the service.")
    count: Optional[StrictInt] = Field(default=None, description="Specifies the number of fixed issues.")
    dependencies: Optional[List[StrictStr]] = Field(default=None, description="Specifies the services for which their patches must be applied together.")
    fixed_issues: Optional[List[FixedIssue]] = Field(default=None, description="Specifies the details of the issues fixed in the patch.", alias="fixedIssues")
    service: Optional[StrictStr] = Field(default=None, description="Specifies the name of the service.")
    version: Optional[StrictStr] = Field(default=None, description="Specifies the version of the patch.")
    __properties: ClassVar[List[str]] = ["component", "count", "dependencies", "fixedIssues", "service", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AvailablePatch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in fixed_issues (list)
        _items = []
        if self.fixed_issues:
            for _item_fixed_issues in self.fixed_issues:
                if _item_fixed_issues:
                    _items.append(_item_fixed_issues.to_dict())
            _dict['fixedIssues'] = _items
        # set to None if dependencies (nullable) is None
        # and model_fields_set contains the field
        if self.dependencies is None and "dependencies" in self.model_fields_set:
            _dict['dependencies'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AvailablePatch from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "component": obj.get("component"),
            "count": obj.get("count"),
            "dependencies": obj.get("dependencies"),
            "fixedIssues": [FixedIssue.from_dict(_item) for _item in obj["fixedIssues"]] if obj.get("fixedIssues") is not None else None,
            "service": obj.get("service"),
            "version": obj.get("version")
        })
        return _obj


