# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.custom_tag_params import CustomTagParams
from typing import Set
from typing_extensions import Self

class AwsCloudSpinParams(BaseModel):
    """
    Specifies various resources when converting and deploying a VM to AWS.
    """ # noqa: E501
    custom_tag_list: Optional[List[CustomTagParams]] = Field(default=None, description="Specifies tags of various resources when converting and deploying a VM to AWS.", alias="customTagList")
    region: Optional[StrictInt] = Field(description="Specifies id of the AWS region in which to deploy the VM.")
    subnet_id: Optional[StrictInt] = Field(default=None, description="Specifies id of the subnet within above VPC.", alias="subnetId")
    vpc_id: Optional[StrictInt] = Field(default=None, description="Specifies id of the Virtual Private Cloud to chose for the instance type.", alias="vpcId")
    __properties: ClassVar[List[str]] = ["customTagList", "region", "subnetId", "vpcId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AwsCloudSpinParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in custom_tag_list (list)
        _items = []
        if self.custom_tag_list:
            for _item_custom_tag_list in self.custom_tag_list:
                if _item_custom_tag_list:
                    _items.append(_item_custom_tag_list.to_dict())
            _dict['customTagList'] = _items
        # set to None if custom_tag_list (nullable) is None
        # and model_fields_set contains the field
        if self.custom_tag_list is None and "custom_tag_list" in self.model_fields_set:
            _dict['customTagList'] = None

        # set to None if region (nullable) is None
        # and model_fields_set contains the field
        if self.region is None and "region" in self.model_fields_set:
            _dict['region'] = None

        # set to None if subnet_id (nullable) is None
        # and model_fields_set contains the field
        if self.subnet_id is None and "subnet_id" in self.model_fields_set:
            _dict['subnetId'] = None

        # set to None if vpc_id (nullable) is None
        # and model_fields_set contains the field
        if self.vpc_id is None and "vpc_id" in self.model_fields_set:
            _dict['vpcId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AwsCloudSpinParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customTagList": [CustomTagParams.from_dict(_item) for _item in obj["customTagList"]] if obj.get("customTagList") is not None else None,
            "region": obj.get("region"),
            "subnetId": obj.get("subnetId"),
            "vpcId": obj.get("vpcId")
        })
        return _obj


