# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.bandwidth_throttling_override import BandwidthThrottlingOverride
from typing import Set
from typing_extensions import Self

class BandwidthThrottling(BaseModel):
    """
    Specifies settings for limiting the data transfer rate between the local and remote Clusters.
    """ # noqa: E501
    rate_limit_bytes_per_sec: Optional[StrictInt] = Field(default=None, description="Specifies the maximum allowed data transfer rate between the local Cluster and remote Clusters.", alias="RateLimitBytesPerSec")
    bandwidth_limit_overrides: Optional[List[BandwidthThrottlingOverride]] = Field(default=None, description="Specifies the max rate limit at which we upload the data.", alias="bandwidthLimitOverrides")
    timezone: Optional[StrictStr] = Field(default=None, description="Specifies a time zone for the specified time period.")
    __properties: ClassVar[List[str]] = ["RateLimitBytesPerSec", "bandwidthLimitOverrides", "timezone"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BandwidthThrottling from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in bandwidth_limit_overrides (list)
        _items = []
        if self.bandwidth_limit_overrides:
            for _item_bandwidth_limit_overrides in self.bandwidth_limit_overrides:
                if _item_bandwidth_limit_overrides:
                    _items.append(_item_bandwidth_limit_overrides.to_dict())
            _dict['bandwidthLimitOverrides'] = _items
        # set to None if rate_limit_bytes_per_sec (nullable) is None
        # and model_fields_set contains the field
        if self.rate_limit_bytes_per_sec is None and "rate_limit_bytes_per_sec" in self.model_fields_set:
            _dict['RateLimitBytesPerSec'] = None

        # set to None if timezone (nullable) is None
        # and model_fields_set contains the field
        if self.timezone is None and "timezone" in self.model_fields_set:
            _dict['timezone'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BandwidthThrottling from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "RateLimitBytesPerSec": obj.get("RateLimitBytesPerSec"),
            "bandwidthLimitOverrides": [BandwidthThrottlingOverride.from_dict(_item) for _item in obj["bandwidthLimitOverrides"]] if obj.get("bandwidthLimitOverrides") is not None else None,
            "timezone": obj.get("timezone")
        })
        return _obj


