# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.one_drive_param import OneDriveParam
from typing import Set
from typing_extensions import Self

class ChannelParam(BaseModel):
    """
    Specifies the parameters to recover a Microsoft 365 Teams Channel.
    """ # noqa: E501
    document_library_params: Optional[List[OneDriveParam]] = Field(default=None, description="Specifies the list of doclibs of the Channel to recover. It is populated iff recoverEntireChannel is false.", alias="documentLibraryParams")
    id: Optional[StrictStr] = Field(description="Specifies the Channel id.")
    name: Optional[StrictStr] = Field(default=None, description="Specifies the Channel name.")
    recover_entire_channel: Optional[StrictBool] = Field(description="Specifies whether to recover the whole Microsoft 365 Channel.", alias="recoverEntireChannel")
    type: Optional[StrictStr] = Field(default=None, description="Specifies the type of channel public or private")
    __properties: ClassVar[List[str]] = ["documentLibraryParams", "id", "name", "recoverEntireChannel", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Private', 'Public']):
            raise ValueError("must be one of enum values ('Private', 'Public')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChannelParam from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in document_library_params (list)
        _items = []
        if self.document_library_params:
            for _item_document_library_params in self.document_library_params:
                if _item_document_library_params:
                    _items.append(_item_document_library_params.to_dict())
            _dict['documentLibraryParams'] = _items
        # set to None if document_library_params (nullable) is None
        # and model_fields_set contains the field
        if self.document_library_params is None and "document_library_params" in self.model_fields_set:
            _dict['documentLibraryParams'] = None

        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if recover_entire_channel (nullable) is None
        # and model_fields_set contains the field
        if self.recover_entire_channel is None and "recover_entire_channel" in self.model_fields_set:
            _dict['recoverEntireChannel'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChannelParam from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "documentLibraryParams": [OneDriveParam.from_dict(_item) for _item in obj["documentLibraryParams"]] if obj.get("documentLibraryParams") is not None else None,
            "id": obj.get("id"),
            "name": obj.get("name"),
            "recoverEntireChannel": obj.get("recoverEntireChannel"),
            "type": obj.get("type")
        })
        return _obj


