# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.data_tiering_analysis_info import DataTieringAnalysisInfo
from cohesity_sdk.cluster.models.data_tiering_object_info import DataTieringObjectInfo
from typing import Set
from typing_extensions import Self

class DataTieringAnalysisGroupRun(BaseModel):
    """
    Specifies the data tiering analysis group run.
    """ # noqa: E501
    analysis_info: Optional[DataTieringAnalysisInfo] = Field(default=None, alias="analysisInfo")
    end_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the end time of analysis run in Unix epoch Timestamp(in microseconds).", alias="endTimeUsecs")
    id: Optional[StrictStr] = Field(default=None, description="Specifies the ID of the data tiering analysis group run.")
    objects: Optional[List[DataTieringObjectInfo]] = Field(default=None, description="Specifies the objects details analyzed during data tiering analysis group run.")
    start_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the start time of analysis run in Unix epoch Timestamp(in microseconds).", alias="startTimeUsecs")
    __properties: ClassVar[List[str]] = ["analysisInfo", "endTimeUsecs", "id", "objects", "startTimeUsecs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataTieringAnalysisGroupRun from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of analysis_info
        if self.analysis_info:
            _dict['analysisInfo'] = self.analysis_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in objects (list)
        _items = []
        if self.objects:
            for _item_objects in self.objects:
                if _item_objects:
                    _items.append(_item_objects.to_dict())
            _dict['objects'] = _items
        # set to None if end_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.end_time_usecs is None and "end_time_usecs" in self.model_fields_set:
            _dict['endTimeUsecs'] = None

        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if objects (nullable) is None
        # and model_fields_set contains the field
        if self.objects is None and "objects" in self.model_fields_set:
            _dict['objects'] = None

        # set to None if start_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.start_time_usecs is None and "start_time_usecs" in self.model_fields_set:
            _dict['startTimeUsecs'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataTieringAnalysisGroupRun from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "analysisInfo": DataTieringAnalysisInfo.from_dict(obj["analysisInfo"]) if obj.get("analysisInfo") is not None else None,
            "endTimeUsecs": obj.get("endTimeUsecs"),
            "id": obj.get("id"),
            "objects": [DataTieringObjectInfo.from_dict(_item) for _item in obj["objects"]] if obj.get("objects") is not None else None,
            "startTimeUsecs": obj.get("startTimeUsecs")
        })
        return _obj


