# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.data_tiering_share_stats import DataTieringShareStats
from cohesity_sdk.cluster.models.data_tiering_tag_object import DataTieringTagObject
from typing import Set
from typing_extensions import Self

class DataTieringObjectAnalysisInfo(BaseModel):
    """
    Specifies the data tiering object analysis details.
    """ # noqa: E501
    message: Optional[StrictStr] = Field(default=None, description="A message about the error if encountered while performing data tiering analysis.")
    stats: Optional[List[DataTieringShareStats]] = Field(default=None, description="Specifies the source share analysis stats.")
    status: Optional[StrictStr] = Field(default=None, description="Status of the analysis run. 'Running' indicates that the run is still running. 'Canceled' indicates that the run has been canceled. 'Canceling' indicates that the run is in the process of being  canceled. 'Failed' indicates that the run has failed. 'Missed' indicates that the run was unable to take place at the  scheduled time because the previous run was still happening. 'Succeeded' indicates that the run has finished successfully. 'SucceededWithWarning' indicates that the run finished  successfully, but there were some warning messages. 'OnHold' indicates that the run has On hold. 'Skipped' indicates that the run was skipped.")
    tags_info: Optional[List[DataTieringTagObject]] = Field(default=None, description="Array of Tag objects.", alias="tagsInfo")
    __properties: ClassVar[List[str]] = ["message", "stats", "status", "tagsInfo"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Accepted', 'Running', 'Canceled', 'Canceling', 'Failed', 'Missed', 'Succeeded', 'SucceededWithWarning', 'OnHold', 'Finalizing', 'Skipped']):
            raise ValueError("must be one of enum values ('Accepted', 'Running', 'Canceled', 'Canceling', 'Failed', 'Missed', 'Succeeded', 'SucceededWithWarning', 'OnHold', 'Finalizing', 'Skipped')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataTieringObjectAnalysisInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in stats (list)
        _items = []
        if self.stats:
            for _item_stats in self.stats:
                if _item_stats:
                    _items.append(_item_stats.to_dict())
            _dict['stats'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tags_info (list)
        _items = []
        if self.tags_info:
            for _item_tags_info in self.tags_info:
                if _item_tags_info:
                    _items.append(_item_tags_info.to_dict())
            _dict['tagsInfo'] = _items
        # set to None if message (nullable) is None
        # and model_fields_set contains the field
        if self.message is None and "message" in self.model_fields_set:
            _dict['message'] = None

        # set to None if stats (nullable) is None
        # and model_fields_set contains the field
        if self.stats is None and "stats" in self.model_fields_set:
            _dict['stats'] = None

        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        # set to None if tags_info (nullable) is None
        # and model_fields_set contains the field
        if self.tags_info is None and "tags_info" in self.model_fields_set:
            _dict['tagsInfo'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataTieringObjectAnalysisInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "message": obj.get("message"),
            "stats": [DataTieringShareStats.from_dict(_item) for _item in obj["stats"]] if obj.get("stats") is not None else None,
            "status": obj.get("status"),
            "tagsInfo": [DataTieringTagObject.from_dict(_item) for _item in obj["tagsInfo"]] if obj.get("tagsInfo") is not None else None
        })
        return _obj


