# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class DnsDelegationZone(BaseModel):
    """
    Dns delegation zone of the vlan.
    """ # noqa: E501
    dns_zone_resolved_vips: Optional[List[StrictStr]] = Field(default=None, description="Dns zone resolved VIPs.", alias="dnsZoneResolvedVips")
    dns_zone_vips: Optional[List[StrictStr]] = Field(default=None, description="VIPs part of dns zone.", alias="dnsZoneVips")
    name: StrictStr = Field(description="Name of dns zone.")
    __properties: ClassVar[List[str]] = ["dnsZoneResolvedVips", "dnsZoneVips", "name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DnsDelegationZone from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if dns_zone_resolved_vips (nullable) is None
        # and model_fields_set contains the field
        if self.dns_zone_resolved_vips is None and "dns_zone_resolved_vips" in self.model_fields_set:
            _dict['dnsZoneResolvedVips'] = None

        # set to None if dns_zone_vips (nullable) is None
        # and model_fields_set contains the field
        if self.dns_zone_vips is None and "dns_zone_vips" in self.model_fields_set:
            _dict['dnsZoneVips'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DnsDelegationZone from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dnsZoneResolvedVips": obj.get("dnsZoneResolvedVips"),
            "dnsZoneVips": obj.get("dnsZoneVips"),
            "name": obj.get("name")
        })
        return _obj


