# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.recovery_object_identifier import RecoveryObjectIdentifier
from typing import Set
from typing_extensions import Self

class EncryptionConfig(BaseModel):
    """
    Specifies the encryption configuration.
    """ # noqa: E501
    custom_kms_key_arn: Optional[StrictStr] = Field(default=None, description="Specifies custom KMS key arn. It will be of form arn:aws:kms:<region>:<account_id>:key/<key_id>", alias="customKmsKeyArn")
    kms_key: Optional[RecoveryObjectIdentifier] = Field(default=None, alias="kmsKey")
    should_encrypt: Optional[StrictBool] = Field(description="Specifies whether to encrypt recovered volumes or not. Default value is true.", alias="shouldEncrypt")
    __properties: ClassVar[List[str]] = ["customKmsKeyArn", "kmsKey", "shouldEncrypt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EncryptionConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of kms_key
        if self.kms_key:
            _dict['kmsKey'] = self.kms_key.to_dict()
        # set to None if custom_kms_key_arn (nullable) is None
        # and model_fields_set contains the field
        if self.custom_kms_key_arn is None and "custom_kms_key_arn" in self.model_fields_set:
            _dict['customKmsKeyArn'] = None

        # set to None if should_encrypt (nullable) is None
        # and model_fields_set contains the field
        if self.should_encrypt is None and "should_encrypt" in self.model_fields_set:
            _dict['shouldEncrypt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EncryptionConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customKmsKeyArn": obj.get("customKmsKeyArn"),
            "kmsKey": RecoveryObjectIdentifier.from_dict(obj["kmsKey"]) if obj.get("kmsKey") is not None else None,
            "shouldEncrypt": obj.get("shouldEncrypt")
        })
        return _obj


