# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.file_id import FileId
from cohesity_sdk.cluster.models.nlm_lock import NlmLock
from typing import Set
from typing_extensions import Self

class FileNlmLocks(BaseModel):
    """
    Specifies NLM locks per file.
    """ # noqa: E501
    file_id: Optional[FileId] = Field(default=None, alias="fileId")
    nlm_locks: Optional[List[NlmLock]] = Field(default=None, description="Specifies the list of NLM locks.", alias="nlmLocks")
    __properties: ClassVar[List[str]] = ["fileId", "nlmLocks"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FileNlmLocks from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of file_id
        if self.file_id:
            _dict['fileId'] = self.file_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in nlm_locks (list)
        _items = []
        if self.nlm_locks:
            for _item_nlm_locks in self.nlm_locks:
                if _item_nlm_locks:
                    _items.append(_item_nlm_locks.to_dict())
            _dict['nlmLocks'] = _items
        # set to None if nlm_locks (nullable) is None
        # and model_fields_set contains the field
        if self.nlm_locks is None and "nlm_locks" in self.model_fields_set:
            _dict['nlmLocks'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FileNlmLocks from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fileId": FileId.from_dict(obj["fileId"]) if obj.get("fileId") is not None else None,
            "nlmLocks": [NlmLock.from_dict(_item) for _item in obj["nlmLocks"]] if obj.get("nlmLocks") is not None else None
        })
        return _obj


