# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class FilerLifecycleAgingPolicy(BaseModel):
    """
    Specifies the aging policy. Note: Both the fields days and dateInUsecs are mutually exclusive to each other.
    """ # noqa: E501
    aging_criteria: Optional[StrictStr] = Field(description="Specifies the criteria for aging", alias="agingCriteria")
    date_in_usecs: Optional[StrictInt] = Field(default=None, description="Files that possess timestamps exceeding the specified value will be eligible for selection.", alias="dateInUsecs")
    days: Optional[StrictInt] = Field(default=None, description="Files that possess timestamps older than the specified value in days will be eligible for selection.")
    __properties: ClassVar[List[str]] = ["agingCriteria", "dateInUsecs", "days"]

    @field_validator('aging_criteria')
    def aging_criteria_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['LastModificationTime', 'CreationTime', 'LastAccessTime']):
            raise ValueError("must be one of enum values ('LastModificationTime', 'CreationTime', 'LastAccessTime')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FilerLifecycleAgingPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if aging_criteria (nullable) is None
        # and model_fields_set contains the field
        if self.aging_criteria is None and "aging_criteria" in self.model_fields_set:
            _dict['agingCriteria'] = None

        # set to None if date_in_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.date_in_usecs is None and "date_in_usecs" in self.model_fields_set:
            _dict['dateInUsecs'] = None

        # set to None if days (nullable) is None
        # and model_fields_set contains the field
        if self.days is None and "days" in self.model_fields_set:
            _dict['days'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FilerLifecycleAgingPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "agingCriteria": obj.get("agingCriteria"),
            "dateInUsecs": obj.get("dateInUsecs"),
            "days": obj.get("days")
        })
        return _obj


