# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.filer_lifecycle_aging_policy import FilerLifecycleAgingPolicy
from cohesity_sdk.cluster.models.filer_lifecycle_rule_filter import FilerLifecycleRuleFilter
from typing import Set
from typing_extensions import Self

class FilerLifecycleRule(BaseModel):
    """
    Specifies the Lifecycle configuration rule.
    """ # noqa: E501
    aging_policy: Optional[FilerLifecycleAgingPolicy] = Field(default=None, alias="agingPolicy")
    file_filter: Optional[FilerLifecycleRuleFilter] = Field(default=None, alias="fileFilter")
    name: Optional[StrictStr] = Field(description="Specifies the Unique identifier for the rule. No 2 rules in a policy should have the same name. The value cannot be longer than 255 characters.")
    status: Optional[StrictStr] = Field(description="Specifies if the rule is currently being applied.")
    type: Optional[StrictStr] = Field(description="Specifies if the rule is Allow or Deny type.")
    __properties: ClassVar[List[str]] = ["agingPolicy", "fileFilter", "name", "status", "type"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Enabled', 'Disabled']):
            raise ValueError("must be one of enum values ('Enabled', 'Disabled')")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Allow', 'Deny']):
            raise ValueError("must be one of enum values ('Allow', 'Deny')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FilerLifecycleRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aging_policy
        if self.aging_policy:
            _dict['agingPolicy'] = self.aging_policy.to_dict()
        # override the default output from pydantic by calling `to_dict()` of file_filter
        if self.file_filter:
            _dict['fileFilter'] = self.file_filter.to_dict()
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FilerLifecycleRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "agingPolicy": FilerLifecycleAgingPolicy.from_dict(obj["agingPolicy"]) if obj.get("agingPolicy") is not None else None,
            "fileFilter": FilerLifecycleRuleFilter.from_dict(obj["fileFilter"]) if obj.get("fileFilter") is not None else None,
            "name": obj.get("name"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj


