# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class FilterDocumentsParams(BaseModel):
    """
    Specifies the parameters to filter documents to be restored.
    """ # noqa: E501
    document_filter_type: Optional[StrictStr] = Field(description="Specifies the filter type for Documents to be restored.", alias="documentFilterType")
    filter_expression: Optional[StrictStr] = Field(default=None, description="A filter expression to match Documents content to be restored.", alias="filterExpression")
    id_regex: Optional[StrictStr] = Field(default=None, description="A regular expression to match Documents ID's to be restored.", alias="idRegex")
    __properties: ClassVar[List[str]] = ["documentFilterType", "filterExpression", "idRegex"]

    @field_validator('document_filter_type')
    def document_filter_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NONE', 'ID', 'CONTENT']):
            raise ValueError("must be one of enum values ('NONE', 'ID', 'CONTENT')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FilterDocumentsParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if document_filter_type (nullable) is None
        # and model_fields_set contains the field
        if self.document_filter_type is None and "document_filter_type" in self.model_fields_set:
            _dict['documentFilterType'] = None

        # set to None if filter_expression (nullable) is None
        # and model_fields_set contains the field
        if self.filter_expression is None and "filter_expression" in self.model_fields_set:
            _dict['filterExpression'] = None

        # set to None if id_regex (nullable) is None
        # and model_fields_set contains the field
        if self.id_regex is None and "id_regex" in self.model_fields_set:
            _dict['idRegex'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FilterDocumentsParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "documentFilterType": obj.get("documentFilterType"),
            "filterExpression": obj.get("filterExpression"),
            "idRegex": obj.get("idRegex")
        })
        return _obj


