# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class GcpVpcSubnetConfig(BaseModel):
    """
    Specifies the group of a GCP VPC and the subnet in it.
    """ # noqa: E501
    subnet_id: Optional[StrictInt] = Field(description="Specifies the id of the subnet.", alias="subnetId")
    subnet_name: Optional[StrictStr] = Field(default=None, description="Specifies the name of the subnet.", alias="subnetName")
    vpc_name: Optional[StrictStr] = Field(default=None, description="Specifies the name of the vpc network.", alias="vpcName")
    __properties: ClassVar[List[str]] = ["subnetId", "subnetName", "vpcName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GcpVpcSubnetConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "subnet_name",
            "vpc_name",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if subnet_id (nullable) is None
        # and model_fields_set contains the field
        if self.subnet_id is None and "subnet_id" in self.model_fields_set:
            _dict['subnetId'] = None

        # set to None if subnet_name (nullable) is None
        # and model_fields_set contains the field
        if self.subnet_name is None and "subnet_name" in self.model_fields_set:
            _dict['subnetName'] = None

        # set to None if vpc_name (nullable) is None
        # and model_fields_set contains the field
        if self.vpc_name is None and "vpc_name" in self.model_fields_set:
            _dict['vpcName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GcpVpcSubnetConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "subnetId": obj.get("subnetId"),
            "subnetName": obj.get("subnetName"),
            "vpcName": obj.get("vpcName")
        })
        return _obj


