# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.keystone_admin_params import KeystoneAdminParams
from cohesity_sdk.cluster.models.keystone_scope_params import KeystoneScopeParams
from typing import Set
from typing_extensions import Self

class Keystone(BaseModel):
    """
    Specifies a Keystone.
    """ # noqa: E501
    admin_creds: KeystoneAdminParams = Field(alias="adminCreds")
    scope: KeystoneScopeParams
    auth_url: Optional[StrictStr] = Field(description="Specifies the url points to the Keystone service.", alias="authUrl")
    id: Optional[StrictInt] = Field(default=None, description="Specifies the Keystone configuration id.")
    name: Optional[StrictStr] = Field(description="Specifies the Keystone configuration name.")
    __properties: ClassVar[List[str]] = ["adminCreds", "scope", "authUrl", "id", "name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Keystone from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of admin_creds
        if self.admin_creds:
            _dict['adminCreds'] = self.admin_creds.to_dict()
        # override the default output from pydantic by calling `to_dict()` of scope
        if self.scope:
            _dict['scope'] = self.scope.to_dict()
        # set to None if auth_url (nullable) is None
        # and model_fields_set contains the field
        if self.auth_url is None and "auth_url" in self.model_fields_set:
            _dict['authUrl'] = None

        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Keystone from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "adminCreds": KeystoneAdminParams.from_dict(obj["adminCreds"]) if obj.get("adminCreds") is not None else None,
            "scope": KeystoneScopeParams.from_dict(obj["scope"]) if obj.get("scope") is not None else None,
            "authUrl": obj.get("authUrl"),
            "id": obj.get("id"),
            "name": obj.get("name")
        })
        return _obj


