# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.kubernetes_pvc_info import KubernetesPvcInfo
from typing import Set
from typing_extensions import Self

class KubernetesProtectionGroupObjectParams(BaseModel):
    """
    Specifies the object parameters to create Kubernetes Protection Group.
    """ # noqa: E501
    exclude_pvcs: Optional[List[Optional[KubernetesPvcInfo]]] = Field(default=None, description="Specifies a list of pvcs to exclude from being protected. This is only applicable to kubernetes.", alias="excludePvcs")
    id: StrictInt = Field(description="Specifies the id of the object.")
    include_pvcs: Optional[List[Optional[KubernetesPvcInfo]]] = Field(default=None, description="Specifies a list of Pvcs to include in the protection. This is only applicable to kubernetes.", alias="includePvcs")
    name: Optional[StrictStr] = Field(default=None, description="Specifies the name of the object.")
    __properties: ClassVar[List[str]] = ["excludePvcs", "id", "includePvcs", "name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of KubernetesProtectionGroupObjectParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "name",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in exclude_pvcs (list)
        _items = []
        if self.exclude_pvcs:
            for _item_exclude_pvcs in self.exclude_pvcs:
                if _item_exclude_pvcs:
                    _items.append(_item_exclude_pvcs.to_dict())
            _dict['excludePvcs'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in include_pvcs (list)
        _items = []
        if self.include_pvcs:
            for _item_include_pvcs in self.include_pvcs:
                if _item_include_pvcs:
                    _items.append(_item_include_pvcs.to_dict())
            _dict['includePvcs'] = _items
        # set to None if exclude_pvcs (nullable) is None
        # and model_fields_set contains the field
        if self.exclude_pvcs is None and "exclude_pvcs" in self.model_fields_set:
            _dict['excludePvcs'] = None

        # set to None if include_pvcs (nullable) is None
        # and model_fields_set contains the field
        if self.include_pvcs is None and "include_pvcs" in self.model_fields_set:
            _dict['includePvcs'] = None

        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of KubernetesProtectionGroupObjectParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "excludePvcs": [KubernetesPvcInfo.from_dict(_item) for _item in obj["excludePvcs"]] if obj.get("excludePvcs") is not None else None,
            "id": obj.get("id"),
            "includePvcs": [KubernetesPvcInfo.from_dict(_item) for _item in obj["includePvcs"]] if obj.get("includePvcs") is not None else None,
            "name": obj.get("name")
        })
        return _obj


