# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.lifecycle_rule_filter_and import LifecycleRuleFilterAnd
from cohesity_sdk.cluster.models.lifecycle_rule_filter_tag import LifecycleRuleFilterTag
from typing import Set
from typing_extensions import Self

class LifecycleRuleFilter(BaseModel):
    """
    Specifies the filter used to identify objects that a Lifecycle Rule applies to. Note: All three properties are mutually exclusive.
    """ # noqa: E501
    var_and: Optional[LifecycleRuleFilterAnd] = Field(default=None, alias="and")
    prefix: Optional[StrictStr] = Field(default=None, description="Specifies the Prefix identifying one or more objects to which the rule applies.")
    tag: Optional[LifecycleRuleFilterTag] = None
    __properties: ClassVar[List[str]] = ["and", "prefix", "tag"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LifecycleRuleFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of var_and
        if self.var_and:
            _dict['and'] = self.var_and.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tag
        if self.tag:
            _dict['tag'] = self.tag.to_dict()
        # set to None if prefix (nullable) is None
        # and model_fields_set contains the field
        if self.prefix is None and "prefix" in self.model_fields_set:
            _dict['prefix'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LifecycleRuleFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "and": LifecycleRuleFilterAnd.from_dict(obj["and"]) if obj.get("and") is not None else None,
            "prefix": obj.get("prefix"),
            "tag": LifecycleRuleFilterTag.from_dict(obj["tag"]) if obj.get("tag") is not None else None
        })
        return _obj


