# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.channel_param import ChannelParam
from typing import Set
from typing_extensions import Self

class MsTeamParam(BaseModel):
    """
    Specifies the parameters to recover a Microsoft 365 Team.
    """ # noqa: E501
    channel_params: Optional[List[ChannelParam]] = Field(default=None, description="Specifies the list of Channels to recover. These are applicable iff recoverEntireMsTeam is false.", alias="channelParams")
    recover_entire_ms_team: Optional[StrictBool] = Field(description="Specifies whether to recover the whole Microsoft 365 Team.", alias="recoverEntireMsTeam")
    __properties: ClassVar[List[str]] = ["channelParams", "recoverEntireMsTeam"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MsTeamParam from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in channel_params (list)
        _items = []
        if self.channel_params:
            for _item_channel_params in self.channel_params:
                if _item_channel_params:
                    _items.append(_item_channel_params.to_dict())
            _dict['channelParams'] = _items
        # set to None if channel_params (nullable) is None
        # and model_fields_set contains the field
        if self.channel_params is None and "channel_params" in self.model_fields_set:
            _dict['channelParams'] = None

        # set to None if recover_entire_ms_team (nullable) is None
        # and model_fields_set contains the field
        if self.recover_entire_ms_team is None and "recover_entire_ms_team" in self.model_fields_set:
            _dict['recoverEntireMsTeam'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MsTeamParam from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "channelParams": [ChannelParam.from_dict(_item) for _item in obj["channelParams"]] if obj.get("channelParams") is not None else None,
            "recoverEntireMsTeam": obj.get("recoverEntireMsTeam")
        })
        return _obj


