# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.nas_full_throttling_config import NasFullThrottlingConfig
from cohesity_sdk.cluster.models.nas_incremental_throttling_config import NasIncrementalThrottlingConfig
from typing import Set
from typing_extensions import Self

class NasThrottlingConfig(BaseModel):
    """
    Specifies the source throttling parameters to be used during full or incremental backup of the NAS source.
    """ # noqa: E501
    full_backup_config: Optional[NasFullThrottlingConfig] = Field(default=None, alias="fullBackupConfig")
    incremental_backup_config: Optional[NasIncrementalThrottlingConfig] = Field(default=None, alias="incrementalBackupConfig")
    __properties: ClassVar[List[str]] = ["fullBackupConfig", "incrementalBackupConfig"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NasThrottlingConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of full_backup_config
        if self.full_backup_config:
            _dict['fullBackupConfig'] = self.full_backup_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of incremental_backup_config
        if self.incremental_backup_config:
            _dict['incrementalBackupConfig'] = self.incremental_backup_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NasThrottlingConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fullBackupConfig": NasFullThrottlingConfig.from_dict(obj["fullBackupConfig"]) if obj.get("fullBackupConfig") is not None else None,
            "incrementalBackupConfig": NasIncrementalThrottlingConfig.from_dict(obj["incrementalBackupConfig"]) if obj.get("incrementalBackupConfig") is not None else None
        })
        return _obj


