# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.free_disk import FreeDisk
from typing import Set
from typing_extensions import Self

class NodeFreeDisks(BaseModel):
    """
    Sepcifies the free disks of a node.
    """ # noqa: E501
    chassis_serial: Optional[StrictStr] = Field(default=None, description="Chassis serial number.", alias="chassisSerial")
    error_message: Optional[StrictStr] = Field(default=None, description="Error message of disks assimilation request.", alias="errorMessage")
    free_disks: Optional[List[FreeDisk]] = Field(description="Specifies list of free disks of node.", alias="freeDisks")
    node_id: Optional[StrictInt] = Field(description="Specifies the id of a node.", alias="nodeId")
    slot: Optional[StrictInt] = Field(default=None, description="Slot number of node")
    __properties: ClassVar[List[str]] = ["chassisSerial", "errorMessage", "freeDisks", "nodeId", "slot"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NodeFreeDisks from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "error_message",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in free_disks (list)
        _items = []
        if self.free_disks:
            for _item_free_disks in self.free_disks:
                if _item_free_disks:
                    _items.append(_item_free_disks.to_dict())
            _dict['freeDisks'] = _items
        # set to None if chassis_serial (nullable) is None
        # and model_fields_set contains the field
        if self.chassis_serial is None and "chassis_serial" in self.model_fields_set:
            _dict['chassisSerial'] = None

        # set to None if error_message (nullable) is None
        # and model_fields_set contains the field
        if self.error_message is None and "error_message" in self.model_fields_set:
            _dict['errorMessage'] = None

        # set to None if free_disks (nullable) is None
        # and model_fields_set contains the field
        if self.free_disks is None and "free_disks" in self.model_fields_set:
            _dict['freeDisks'] = None

        # set to None if node_id (nullable) is None
        # and model_fields_set contains the field
        if self.node_id is None and "node_id" in self.model_fields_set:
            _dict['nodeId'] = None

        # set to None if slot (nullable) is None
        # and model_fields_set contains the field
        if self.slot is None and "slot" in self.model_fields_set:
            _dict['slot'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NodeFreeDisks from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chassisSerial": obj.get("chassisSerial"),
            "errorMessage": obj.get("errorMessage"),
            "freeDisks": [FreeDisk.from_dict(_item) for _item in obj["freeDisks"]] if obj.get("freeDisks") is not None else None,
            "nodeId": obj.get("nodeId"),
            "slot": obj.get("slot")
        })
        return _obj


