# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class NodeRemovalParams(BaseModel):
    """
    Specifies parameters to initiate/cancel node removal.
    """ # noqa: E501
    cancel: Optional[StrictBool] = Field(description="If true, cancels node removal that is already in progress.")
    is_offline: Optional[StrictBool] = Field(default=False, description="Specifies whether node being removed is offline.", alias="isOffline")
    is_validate_only: Optional[StrictBool] = Field(default=False, description="Specifies whether request is for pre-check validations only", alias="isValidateOnly")
    __properties: ClassVar[List[str]] = ["cancel", "isOffline", "isValidateOnly"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NodeRemovalParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if cancel (nullable) is None
        # and model_fields_set contains the field
        if self.cancel is None and "cancel" in self.model_fields_set:
            _dict['cancel'] = None

        # set to None if is_offline (nullable) is None
        # and model_fields_set contains the field
        if self.is_offline is None and "is_offline" in self.model_fields_set:
            _dict['isOffline'] = None

        # set to None if is_validate_only (nullable) is None
        # and model_fields_set contains the field
        if self.is_validate_only is None and "is_validate_only" in self.model_fields_set:
            _dict['isValidateOnly'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NodeRemovalParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cancel": obj.get("cancel"),
            "isOffline": obj.get("isOffline") if obj.get("isOffline") is not None else False,
            "isValidateOnly": obj.get("isValidateOnly") if obj.get("isValidateOnly") is not None else False
        })
        return _obj


