# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class O365SearchRequestParams(BaseModel):
    """
    Specifies O365 specific params search request params to search for indexed items.
    """ # noqa: E501
    domain_ids: Optional[List[StrictInt]] = Field(default=None, description="Specifies the domain Ids in which indexed items are searched.", alias="domainIds")
    group_ids: Optional[List[StrictInt]] = Field(default=None, description="Specifies the Group ids across which the indexed items needs to be searched.", alias="groupIds")
    site_ids: Optional[List[StrictInt]] = Field(default=None, description="Specifies the Sharepoint site ids across which the indexed items needs to be searched.", alias="siteIds")
    teams_ids: Optional[List[StrictInt]] = Field(default=None, description="Specifies the Teams ids across which the indexed items needs to be searched.", alias="teamsIds")
    user_ids: Optional[List[StrictInt]] = Field(default=None, description="Specifies the user ids across which the indexed items needs to be searched.", alias="userIds")
    __properties: ClassVar[List[str]] = ["domainIds", "groupIds", "siteIds", "teamsIds", "userIds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of O365SearchRequestParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if domain_ids (nullable) is None
        # and model_fields_set contains the field
        if self.domain_ids is None and "domain_ids" in self.model_fields_set:
            _dict['domainIds'] = None

        # set to None if group_ids (nullable) is None
        # and model_fields_set contains the field
        if self.group_ids is None and "group_ids" in self.model_fields_set:
            _dict['groupIds'] = None

        # set to None if site_ids (nullable) is None
        # and model_fields_set contains the field
        if self.site_ids is None and "site_ids" in self.model_fields_set:
            _dict['siteIds'] = None

        # set to None if teams_ids (nullable) is None
        # and model_fields_set contains the field
        if self.teams_ids is None and "teams_ids" in self.model_fields_set:
            _dict['teamsIds'] = None

        # set to None if user_ids (nullable) is None
        # and model_fields_set contains the field
        if self.user_ids is None and "user_ids" in self.model_fields_set:
            _dict['userIds'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of O365SearchRequestParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "domainIds": obj.get("domainIds"),
            "groupIds": obj.get("groupIds"),
            "siteIds": obj.get("siteIds"),
            "teamsIds": obj.get("teamsIds"),
            "userIds": obj.get("userIds")
        })
        return _obj


