# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.key_value_pair import KeyValuePair
from typing import Set
from typing_extensions import Self

class OracleRestoreMetaInfoResult(BaseModel):
    """
    Result to store oracle meta-info from snapshot id and other oracle params.
    """ # noqa: E501
    cohesity_pfile_param_map: Optional[List[KeyValuePair]] = Field(default=None, description="Specifies map for cohesity controlled pfile params.", alias="cohesityPfileParamMap")
    inherited_pfile_param_map: Optional[List[KeyValuePair]] = Field(default=None, description="Specifies map for inherited pfile params.", alias="inheritedPfileParamMap")
    restricted_pfile_param_map: Optional[List[KeyValuePair]] = Field(default=None, description="Specifies map for restricted pfile params.", alias="restrictedPfileParamMap")
    __properties: ClassVar[List[str]] = ["cohesityPfileParamMap", "inheritedPfileParamMap", "restrictedPfileParamMap"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OracleRestoreMetaInfoResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in cohesity_pfile_param_map (list)
        _items = []
        if self.cohesity_pfile_param_map:
            for _item_cohesity_pfile_param_map in self.cohesity_pfile_param_map:
                if _item_cohesity_pfile_param_map:
                    _items.append(_item_cohesity_pfile_param_map.to_dict())
            _dict['cohesityPfileParamMap'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in inherited_pfile_param_map (list)
        _items = []
        if self.inherited_pfile_param_map:
            for _item_inherited_pfile_param_map in self.inherited_pfile_param_map:
                if _item_inherited_pfile_param_map:
                    _items.append(_item_inherited_pfile_param_map.to_dict())
            _dict['inheritedPfileParamMap'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in restricted_pfile_param_map (list)
        _items = []
        if self.restricted_pfile_param_map:
            for _item_restricted_pfile_param_map in self.restricted_pfile_param_map:
                if _item_restricted_pfile_param_map:
                    _items.append(_item_restricted_pfile_param_map.to_dict())
            _dict['restrictedPfileParamMap'] = _items
        # set to None if cohesity_pfile_param_map (nullable) is None
        # and model_fields_set contains the field
        if self.cohesity_pfile_param_map is None and "cohesity_pfile_param_map" in self.model_fields_set:
            _dict['cohesityPfileParamMap'] = None

        # set to None if inherited_pfile_param_map (nullable) is None
        # and model_fields_set contains the field
        if self.inherited_pfile_param_map is None and "inherited_pfile_param_map" in self.model_fields_set:
            _dict['inheritedPfileParamMap'] = None

        # set to None if restricted_pfile_param_map (nullable) is None
        # and model_fields_set contains the field
        if self.restricted_pfile_param_map is None and "restricted_pfile_param_map" in self.model_fields_set:
            _dict['restrictedPfileParamMap'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OracleRestoreMetaInfoResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cohesityPfileParamMap": [KeyValuePair.from_dict(_item) for _item in obj["cohesityPfileParamMap"]] if obj.get("cohesityPfileParamMap") is not None else None,
            "inheritedPfileParamMap": [KeyValuePair.from_dict(_item) for _item in obj["inheritedPfileParamMap"]] if obj.get("inheritedPfileParamMap") is not None else None,
            "restrictedPfileParamMap": [KeyValuePair.from_dict(_item) for _item in obj["restrictedPfileParamMap"]] if obj.get("restrictedPfileParamMap") is not None else None
        })
        return _obj


