# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.common_recover_file_and_folder_info import CommonRecoverFileAndFolderInfo
from cohesity_sdk.cluster.models.hyper_v_target_params_for_recover_file_and_folder import HyperVTargetParamsForRecoverFileAndFolder
from typing import Set
from typing_extensions import Self

class RecoverHyperVFileAndFolderParams(BaseModel):
    """
    Specifies the parameters to recover files and folders.
    """ # noqa: E501
    files_and_folders: Optional[List[CommonRecoverFileAndFolderInfo]] = Field(description="Specifies the info about the files and folders to be recovered.", alias="filesAndFolders")
    hyperv_target_params: Optional[HyperVTargetParamsForRecoverFileAndFolder] = Field(default=None, alias="hypervTargetParams")
    target_environment: StrictStr = Field(description="Specifies the environment of the recovery target. The corresponding params below must be filled out.", alias="targetEnvironment")
    __properties: ClassVar[List[str]] = ["filesAndFolders", "hypervTargetParams", "targetEnvironment"]

    @field_validator('target_environment')
    def target_environment_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['kHyperV']):
            raise ValueError("must be one of enum values ('kHyperV')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RecoverHyperVFileAndFolderParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in files_and_folders (list)
        _items = []
        if self.files_and_folders:
            for _item_files_and_folders in self.files_and_folders:
                if _item_files_and_folders:
                    _items.append(_item_files_and_folders.to_dict())
            _dict['filesAndFolders'] = _items
        # override the default output from pydantic by calling `to_dict()` of hyperv_target_params
        if self.hyperv_target_params:
            _dict['hypervTargetParams'] = self.hyperv_target_params.to_dict()
        # set to None if files_and_folders (nullable) is None
        # and model_fields_set contains the field
        if self.files_and_folders is None and "files_and_folders" in self.model_fields_set:
            _dict['filesAndFolders'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RecoverHyperVFileAndFolderParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "filesAndFolders": [CommonRecoverFileAndFolderInfo.from_dict(_item) for _item in obj["filesAndFolders"]] if obj.get("filesAndFolders") is not None else None,
            "hypervTargetParams": HyperVTargetParamsForRecoverFileAndFolder.from_dict(obj["hypervTargetParams"]) if obj.get("hypervTargetParams") is not None else None,
            "targetEnvironment": obj.get("targetEnvironment")
        })
        return _obj


