# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.common_download_file_and_folder_params import CommonDownloadFileAndFolderParams
from cohesity_sdk.cluster.models.common_recover_object_snapshot_params import CommonRecoverObjectSnapshotParams
from cohesity_sdk.cluster.models.download_chats_params import DownloadChatsParams
from cohesity_sdk.cluster.models.recover_mailbox_params import RecoverMailboxParams
from cohesity_sdk.cluster.models.recover_ms_group_params import RecoverMsGroupParams
from cohesity_sdk.cluster.models.recover_ms_team_params import RecoverMsTeamParams
from cohesity_sdk.cluster.models.recover_one_drive_params import RecoverOneDriveParams
from cohesity_sdk.cluster.models.recover_public_folders_params import RecoverPublicFoldersParams
from cohesity_sdk.cluster.models.recover_site_params import RecoverSiteParams
from typing import Set
from typing_extensions import Self

class RecoverO365Params(BaseModel):
    """
    Specifies the recovery options specific to Office 365 environment.
    """ # noqa: E501
    download_chats_params: Optional[DownloadChatsParams] = Field(default=None, alias="downloadChatsParams")
    download_file_and_folder_params: Optional[CommonDownloadFileAndFolderParams] = Field(default=None, alias="downloadFileAndFolderParams")
    objects: Optional[List[CommonRecoverObjectSnapshotParams]] = Field(default=None, description="Specifies the list of recover Object parameters.")
    recover_mailbox_params: Optional[RecoverMailboxParams] = Field(default=None, alias="recoverMailboxParams")
    recover_ms_group_params: Optional[RecoverMsGroupParams] = Field(default=None, alias="recoverMsGroupParams")
    recover_ms_team_params: Optional[RecoverMsTeamParams] = Field(default=None, alias="recoverMsTeamParams")
    recover_one_drive_params: Optional[RecoverOneDriveParams] = Field(default=None, alias="recoverOneDriveParams")
    recover_public_folders_params: Optional[RecoverPublicFoldersParams] = Field(default=None, alias="recoverPublicFoldersParams")
    recover_site_params: Optional[RecoverSiteParams] = Field(default=None, alias="recoverSiteParams")
    recovery_action: StrictStr = Field(description="Specifies the type of recovery action to be performed.", alias="recoveryAction")
    __properties: ClassVar[List[str]] = ["downloadChatsParams", "downloadFileAndFolderParams", "objects", "recoverMailboxParams", "recoverMsGroupParams", "recoverMsTeamParams", "recoverOneDriveParams", "recoverPublicFoldersParams", "recoverSiteParams", "recoveryAction"]

    @field_validator('recovery_action')
    def recovery_action_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['RecoverMailbox', 'RecoverOneDrive', 'RecoverSharePoint', 'RecoverPublicFolders', 'RecoverMsGroup', 'RecoverMsTeam', 'ConvertToPst', 'DownloadChats']):
            raise ValueError("must be one of enum values ('RecoverMailbox', 'RecoverOneDrive', 'RecoverSharePoint', 'RecoverPublicFolders', 'RecoverMsGroup', 'RecoverMsTeam', 'ConvertToPst', 'DownloadChats')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RecoverO365Params from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of download_chats_params
        if self.download_chats_params:
            _dict['downloadChatsParams'] = self.download_chats_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of download_file_and_folder_params
        if self.download_file_and_folder_params:
            _dict['downloadFileAndFolderParams'] = self.download_file_and_folder_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in objects (list)
        _items = []
        if self.objects:
            for _item_objects in self.objects:
                if _item_objects:
                    _items.append(_item_objects.to_dict())
            _dict['objects'] = _items
        # override the default output from pydantic by calling `to_dict()` of recover_mailbox_params
        if self.recover_mailbox_params:
            _dict['recoverMailboxParams'] = self.recover_mailbox_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recover_ms_group_params
        if self.recover_ms_group_params:
            _dict['recoverMsGroupParams'] = self.recover_ms_group_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recover_ms_team_params
        if self.recover_ms_team_params:
            _dict['recoverMsTeamParams'] = self.recover_ms_team_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recover_one_drive_params
        if self.recover_one_drive_params:
            _dict['recoverOneDriveParams'] = self.recover_one_drive_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recover_public_folders_params
        if self.recover_public_folders_params:
            _dict['recoverPublicFoldersParams'] = self.recover_public_folders_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recover_site_params
        if self.recover_site_params:
            _dict['recoverSiteParams'] = self.recover_site_params.to_dict()
        # set to None if objects (nullable) is None
        # and model_fields_set contains the field
        if self.objects is None and "objects" in self.model_fields_set:
            _dict['objects'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RecoverO365Params from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "downloadChatsParams": DownloadChatsParams.from_dict(obj["downloadChatsParams"]) if obj.get("downloadChatsParams") is not None else None,
            "downloadFileAndFolderParams": CommonDownloadFileAndFolderParams.from_dict(obj["downloadFileAndFolderParams"]) if obj.get("downloadFileAndFolderParams") is not None else None,
            "objects": [CommonRecoverObjectSnapshotParams.from_dict(_item) for _item in obj["objects"]] if obj.get("objects") is not None else None,
            "recoverMailboxParams": RecoverMailboxParams.from_dict(obj["recoverMailboxParams"]) if obj.get("recoverMailboxParams") is not None else None,
            "recoverMsGroupParams": RecoverMsGroupParams.from_dict(obj["recoverMsGroupParams"]) if obj.get("recoverMsGroupParams") is not None else None,
            "recoverMsTeamParams": RecoverMsTeamParams.from_dict(obj["recoverMsTeamParams"]) if obj.get("recoverMsTeamParams") is not None else None,
            "recoverOneDriveParams": RecoverOneDriveParams.from_dict(obj["recoverOneDriveParams"]) if obj.get("recoverOneDriveParams") is not None else None,
            "recoverPublicFoldersParams": RecoverPublicFoldersParams.from_dict(obj["recoverPublicFoldersParams"]) if obj.get("recoverPublicFoldersParams") is not None else None,
            "recoverSiteParams": RecoverSiteParams.from_dict(obj["recoverSiteParams"]) if obj.get("recoverSiteParams") is not None else None,
            "recoveryAction": obj.get("recoveryAction")
        })
        return _obj


