# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.common_oracle_app_source_config import CommonOracleAppSourceConfig
from cohesity_sdk.cluster.models.recovery_object_identifier import RecoveryObjectIdentifier
from typing import Set
from typing_extensions import Self

class RecoverOracleAppNewSourceConfig(BaseModel):
    """
    Specifies the new destination Source configuration where the databases will be recovered.
    """ # noqa: E501
    host: RecoveryObjectIdentifier
    recover_database_params: Optional[CommonOracleAppSourceConfig] = Field(default=None, alias="recoverDatabaseParams")
    recover_view_params: Optional[CommonOracleAppSourceConfig] = Field(default=None, alias="recoverViewParams")
    recovery_target: Optional[StrictStr] = Field(default=None, description="Specifies if recovery target is a database or a view.", alias="recoveryTarget")
    __properties: ClassVar[List[str]] = ["host", "recoverDatabaseParams", "recoverViewParams", "recoveryTarget"]

    @field_validator('recovery_target')
    def recovery_target_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['RecoverDatabase', 'RecoverView']):
            raise ValueError("must be one of enum values ('RecoverDatabase', 'RecoverView')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RecoverOracleAppNewSourceConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of host
        if self.host:
            _dict['host'] = self.host.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recover_database_params
        if self.recover_database_params:
            _dict['recoverDatabaseParams'] = self.recover_database_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recover_view_params
        if self.recover_view_params:
            _dict['recoverViewParams'] = self.recover_view_params.to_dict()
        # set to None if recovery_target (nullable) is None
        # and model_fields_set contains the field
        if self.recovery_target is None and "recovery_target" in self.model_fields_set:
            _dict['recoveryTarget'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RecoverOracleAppNewSourceConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "host": RecoveryObjectIdentifier.from_dict(obj["host"]) if obj.get("host") is not None else None,
            "recoverDatabaseParams": CommonOracleAppSourceConfig.from_dict(obj["recoverDatabaseParams"]) if obj.get("recoverDatabaseParams") is not None else None,
            "recoverViewParams": CommonOracleAppSourceConfig.from_dict(obj["recoverViewParams"]) if obj.get("recoverViewParams") is not None else None,
            "recoveryTarget": obj.get("recoveryTarget")
        })
        return _obj


