# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.object_site_param import ObjectSiteParam
from cohesity_sdk.cluster.models.recovery_object_identifier import RecoveryObjectIdentifier
from cohesity_sdk.cluster.models.target_site_param import TargetSiteParam
from typing import Set
from typing_extensions import Self

class RecoverSiteParams(BaseModel):
    """
    Specifies the parameters to recover Microsoft Office 365 Sharepoint site.
    """ # noqa: E501
    continue_on_error: Optional[StrictBool] = Field(default=None, description="Specifies whether to continue recovering the doc libs of a site, if one or more of doc libs failed to recover. Default value is false.", alias="continueOnError")
    objects: Optional[List[ObjectSiteParam]] = Field(description="Specifies a list of site params associated with the objects to recover.")
    recover_preservation_hold_library: Optional[StrictBool] = Field(default=None, description="Specifies whether to recover Preservation Hold Library associated with the Sites selected for restore. Default value is false.", alias="recoverPreservationHoldLibrary")
    target_domain_object_id: Optional[RecoveryObjectIdentifier] = Field(default=None, alias="targetDomainObjectId")
    target_site: Optional[TargetSiteParam] = Field(default=None, alias="targetSite")
    __properties: ClassVar[List[str]] = ["continueOnError", "objects", "recoverPreservationHoldLibrary", "targetDomainObjectId", "targetSite"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RecoverSiteParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in objects (list)
        _items = []
        if self.objects:
            for _item_objects in self.objects:
                if _item_objects:
                    _items.append(_item_objects.to_dict())
            _dict['objects'] = _items
        # override the default output from pydantic by calling `to_dict()` of target_domain_object_id
        if self.target_domain_object_id:
            _dict['targetDomainObjectId'] = self.target_domain_object_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of target_site
        if self.target_site:
            _dict['targetSite'] = self.target_site.to_dict()
        # set to None if continue_on_error (nullable) is None
        # and model_fields_set contains the field
        if self.continue_on_error is None and "continue_on_error" in self.model_fields_set:
            _dict['continueOnError'] = None

        # set to None if objects (nullable) is None
        # and model_fields_set contains the field
        if self.objects is None and "objects" in self.model_fields_set:
            _dict['objects'] = None

        # set to None if recover_preservation_hold_library (nullable) is None
        # and model_fields_set contains the field
        if self.recover_preservation_hold_library is None and "recover_preservation_hold_library" in self.model_fields_set:
            _dict['recoverPreservationHoldLibrary'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RecoverSiteParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "continueOnError": obj.get("continueOnError"),
            "objects": [ObjectSiteParam.from_dict(_item) for _item in obj["objects"]] if obj.get("objects") is not None else None,
            "recoverPreservationHoldLibrary": obj.get("recoverPreservationHoldLibrary"),
            "targetDomainObjectId": RecoveryObjectIdentifier.from_dict(obj["targetDomainObjectId"]) if obj.get("targetDomainObjectId") is not None else None,
            "targetSite": TargetSiteParam.from_dict(obj["targetSite"]) if obj.get("targetSite") is not None else None
        })
        return _obj


