# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class RigelClusterNode(BaseModel):
    """
    Params for a Rigel Cluster Node
    """ # noqa: E501
    node_id: Optional[StrictInt] = Field(default=None, description="Specifies the ID of the Node.", alias="nodeId")
    node_ip: Optional[StrictStr] = Field(description="Specifies the IP address of the Node.", alias="nodeIp")
    secondary_node_ip: Optional[StrictStr] = Field(default=None, description="Specifies the secondary IP address of the Node.", alias="secondaryNodeIp")
    __properties: ClassVar[List[str]] = ["nodeId", "nodeIp", "secondaryNodeIp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RigelClusterNode from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if node_id (nullable) is None
        # and model_fields_set contains the field
        if self.node_id is None and "node_id" in self.model_fields_set:
            _dict['nodeId'] = None

        # set to None if node_ip (nullable) is None
        # and model_fields_set contains the field
        if self.node_ip is None and "node_ip" in self.model_fields_set:
            _dict['nodeIp'] = None

        # set to None if secondary_node_ip (nullable) is None
        # and model_fields_set contains the field
        if self.secondary_node_ip is None and "secondary_node_ip" in self.model_fields_set:
            _dict['secondaryNodeIp'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RigelClusterNode from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "nodeId": obj.get("nodeId"),
            "nodeIp": obj.get("nodeIp"),
            "secondaryNodeIp": obj.get("secondaryNodeIp")
        })
        return _obj


