# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.rigel_claim_info import RigelClaimInfo
from cohesity_sdk.cluster.models.rigel_connection_info import RigelConnectionInfo
from typing import Set
from typing_extensions import Self

class RigelRegConfig(BaseModel):
    """
    Specifies the Rigel Registration Config.
    """ # noqa: E501
    control_plane_connection_info: Optional[RigelConnectionInfo] = Field(default=None, alias="controlPlaneConnectionInfo")
    data_plane_connection_info: Optional[RigelConnectionInfo] = Field(default=None, alias="dataPlaneConnectionInfo")
    is_certificate_valid: Optional[StrictBool] = Field(default=None, description="Flag to indicate if certificate is valid.", alias="isCertificateValid")
    reg_info: Optional[RigelClaimInfo] = Field(default=None, alias="regInfo")
    __properties: ClassVar[List[str]] = ["controlPlaneConnectionInfo", "dataPlaneConnectionInfo", "isCertificateValid", "regInfo"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RigelRegConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of control_plane_connection_info
        if self.control_plane_connection_info:
            _dict['controlPlaneConnectionInfo'] = self.control_plane_connection_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data_plane_connection_info
        if self.data_plane_connection_info:
            _dict['dataPlaneConnectionInfo'] = self.data_plane_connection_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of reg_info
        if self.reg_info:
            _dict['regInfo'] = self.reg_info.to_dict()
        # set to None if is_certificate_valid (nullable) is None
        # and model_fields_set contains the field
        if self.is_certificate_valid is None and "is_certificate_valid" in self.model_fields_set:
            _dict['isCertificateValid'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RigelRegConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "controlPlaneConnectionInfo": RigelConnectionInfo.from_dict(obj["controlPlaneConnectionInfo"]) if obj.get("controlPlaneConnectionInfo") is not None else None,
            "dataPlaneConnectionInfo": RigelConnectionInfo.from_dict(obj["dataPlaneConnectionInfo"]) if obj.get("dataPlaneConnectionInfo") is not None else None,
            "isCertificateValid": obj.get("isCertificateValid"),
            "regInfo": RigelClaimInfo.from_dict(obj["regInfo"]) if obj.get("regInfo") is not None else None
        })
        return _obj


