# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Set
from typing_extensions import Self

class SecurityConfigAccountLockout(BaseModel):
    """
    Specifies security config for account lockout.
    """ # noqa: E501
    failed_login_lock_time_duration_mins: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(default=None, description="Specifies the time duration within which the consecutive failed login attempts causes a local user account to be locked and the lockout duration time due to that.", alias="failedLoginLockTimeDurationMins")
    inactivity_time_days: Optional[Annotated[int, Field(le=365, strict=True, ge=1)]] = Field(default=None, description="Specifies the lockout inactivity time range in days.", alias="inactivityTimeDays")
    max_failed_login_attempts: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(default=None, description="Specifies the maximum number of consecutive fail login attempts.", alias="maxFailedLoginAttempts")
    __properties: ClassVar[List[str]] = ["failedLoginLockTimeDurationMins", "inactivityTimeDays", "maxFailedLoginAttempts"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SecurityConfigAccountLockout from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if failed_login_lock_time_duration_mins (nullable) is None
        # and model_fields_set contains the field
        if self.failed_login_lock_time_duration_mins is None and "failed_login_lock_time_duration_mins" in self.model_fields_set:
            _dict['failedLoginLockTimeDurationMins'] = None

        # set to None if inactivity_time_days (nullable) is None
        # and model_fields_set contains the field
        if self.inactivity_time_days is None and "inactivity_time_days" in self.model_fields_set:
            _dict['inactivityTimeDays'] = None

        # set to None if max_failed_login_attempts (nullable) is None
        # and model_fields_set contains the field
        if self.max_failed_login_attempts is None and "max_failed_login_attempts" in self.model_fields_set:
            _dict['maxFailedLoginAttempts'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SecurityConfigAccountLockout from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "failedLoginLockTimeDurationMins": obj.get("failedLoginLockTimeDurationMins"),
            "inactivityTimeDays": obj.get("inactivityTimeDays"),
            "maxFailedLoginAttempts": obj.get("maxFailedLoginAttempts")
        })
        return _obj


