# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Set
from typing_extensions import Self

class SlaRule(BaseModel):
    """
    Specifies an SLA rule for a specific Protection Group run type.
    """ # noqa: E501
    backup_run_type: Optional[StrictStr] = Field(default=None, description="Specifies the type of run this rule should apply to.", alias="backupRunType")
    sla_minutes: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(default=None, description="Specifies the number of minutes allotted to a run of the specified type before SLA is considered violated.", alias="slaMinutes")
    __properties: ClassVar[List[str]] = ["backupRunType", "slaMinutes"]

    @field_validator('backup_run_type')
    def backup_run_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kIncremental', 'kFull', 'kLog']):
            raise ValueError("must be one of enum values ('kIncremental', 'kFull', 'kLog')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SlaRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if backup_run_type (nullable) is None
        # and model_fields_set contains the field
        if self.backup_run_type is None and "backup_run_type" in self.model_fields_set:
            _dict['backupRunType'] = None

        # set to None if sla_minutes (nullable) is None
        # and model_fields_set contains the field
        if self.sla_minutes is None and "sla_minutes" in self.model_fields_set:
            _dict['slaMinutes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SlaRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "backupRunType": obj.get("backupRunType"),
            "slaMinutes": obj.get("slaMinutes")
        })
        return _obj


