# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.iam_role_aws_credentials import IamRoleAwsCredentials
from cohesity_sdk.cluster.models.iam_user_aws_credentials import IamUserAwsCredentials
from typing import Set
from typing_extensions import Self

class StandardParams(BaseModel):
    """
    Specifies the parameters to register a commercial AWS
    """ # noqa: E501
    auth_method_type: Optional[StrictStr] = Field(description="Specifies the Authentication method(IamArn/IamRole) used by api", alias="authMethodType")
    iam_role_aws_credentials: Optional[IamRoleAwsCredentials] = Field(default=None, alias="iamRoleAwsCredentials")
    iam_user_aws_credentials: Optional[IamUserAwsCredentials] = Field(default=None, alias="iamUserAwsCredentials")
    __properties: ClassVar[List[str]] = ["authMethodType", "iamRoleAwsCredentials", "iamUserAwsCredentials"]

    @field_validator('auth_method_type')
    def auth_method_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kUseIAMUser', 'kUseIAMRole']):
            raise ValueError("must be one of enum values ('kUseIAMUser', 'kUseIAMRole')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of iam_role_aws_credentials
        if self.iam_role_aws_credentials:
            _dict['iamRoleAwsCredentials'] = self.iam_role_aws_credentials.to_dict()
        # override the default output from pydantic by calling `to_dict()` of iam_user_aws_credentials
        if self.iam_user_aws_credentials:
            _dict['iamUserAwsCredentials'] = self.iam_user_aws_credentials.to_dict()
        # set to None if auth_method_type (nullable) is None
        # and model_fields_set contains the field
        if self.auth_method_type is None and "auth_method_type" in self.model_fields_set:
            _dict['authMethodType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "authMethodType": obj.get("authMethodType"),
            "iamRoleAwsCredentials": IamRoleAwsCredentials.from_dict(obj["iamRoleAwsCredentials"]) if obj.get("iamRoleAwsCredentials") is not None else None,
            "iamUserAwsCredentials": IamUserAwsCredentials.from_dict(obj["iamUserAwsCredentials"]) if obj.get("iamUserAwsCredentials") is not None else None
        })
        return _obj


