# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.storage_domain import StorageDomain
from typing import Set
from typing_extensions import Self

class StorageDomains(BaseModel):
    """
    Specifies a list of Storage Domains.
    """ # noqa: E501
    storage_domains: Optional[List[StorageDomain]] = Field(default=None, description="Specifies the list of storage domains.", alias="storageDomains")
    __properties: ClassVar[List[str]] = ["storageDomains"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StorageDomains from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in storage_domains (list)
        _items = []
        if self.storage_domains:
            for _item_storage_domains in self.storage_domains:
                if _item_storage_domains:
                    _items.append(_item_storage_domains.to_dict())
            _dict['storageDomains'] = _items
        # set to None if storage_domains (nullable) is None
        # and model_fields_set contains the field
        if self.storage_domains is None and "storage_domains" in self.model_fields_set:
            _dict['storageDomains'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StorageDomains from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "storageDomains": [StorageDomain.from_dict(_item) for _item in obj["storageDomains"]] if obj.get("storageDomains") is not None else None
        })
        return _obj


