# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class SwiftConfig(BaseModel):
    """
    Specifies the Swift config settings for this View.
    """ # noqa: E501
    swift_project_domain: Optional[StrictStr] = Field(default=None, description="Specifies the Keystone project domain.", alias="swiftProjectDomain")
    swift_project_name: Optional[StrictStr] = Field(default=None, description="Specifies the Keystone project name.", alias="swiftProjectName")
    swift_user_domain: Optional[StrictStr] = Field(default=None, description="Specifies the Keystone user domain.", alias="swiftUserDomain")
    swift_username: Optional[StrictStr] = Field(default=None, description="Specifies the Keystone username.", alias="swiftUsername")
    __properties: ClassVar[List[str]] = ["swiftProjectDomain", "swiftProjectName", "swiftUserDomain", "swiftUsername"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SwiftConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if swift_project_domain (nullable) is None
        # and model_fields_set contains the field
        if self.swift_project_domain is None and "swift_project_domain" in self.model_fields_set:
            _dict['swiftProjectDomain'] = None

        # set to None if swift_project_name (nullable) is None
        # and model_fields_set contains the field
        if self.swift_project_name is None and "swift_project_name" in self.model_fields_set:
            _dict['swiftProjectName'] = None

        # set to None if swift_user_domain (nullable) is None
        # and model_fields_set contains the field
        if self.swift_user_domain is None and "swift_user_domain" in self.model_fields_set:
            _dict['swiftUserDomain'] = None

        # set to None if swift_username (nullable) is None
        # and model_fields_set contains the field
        if self.swift_username is None and "swift_username" in self.model_fields_set:
            _dict['swiftUsername'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SwiftConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "swiftProjectDomain": obj.get("swiftProjectDomain"),
            "swiftProjectName": obj.get("swiftProjectName"),
            "swiftUserDomain": obj.get("swiftUserDomain"),
            "swiftUsername": obj.get("swiftUsername")
        })
        return _obj


