# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class SystemAppStatusParams(BaseModel):
    """
    Specifies the status of each system app on the cluster.
    """ # noqa: E501
    available_replicas: Optional[StrictInt] = Field(default=None, description="Specifies the number of available replicas.", alias="availableReplicas")
    configured_replicas: Optional[StrictInt] = Field(default=None, description="Specifies the number of configured replicas.", alias="configuredReplicas")
    name: Optional[StrictStr] = Field(default=None, description="Specifies the name of the system app.")
    ready_replicas: Optional[StrictInt] = Field(default=None, description="Specifies the number of ready replicas.", alias="readyReplicas")
    service_endpoint: Optional[StrictStr] = Field(default=None, description="Specifies the service endpoint.", alias="serviceEndpoint")
    __properties: ClassVar[List[str]] = ["availableReplicas", "configuredReplicas", "name", "readyReplicas", "serviceEndpoint"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SystemAppStatusParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SystemAppStatusParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "availableReplicas": obj.get("availableReplicas"),
            "configuredReplicas": obj.get("configuredReplicas"),
            "name": obj.get("name"),
            "readyReplicas": obj.get("readyReplicas"),
            "serviceEndpoint": obj.get("serviceEndpoint")
        })
        return _obj


