# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.ebs_tag import EBSTag
from typing import Set
from typing_extensions import Self

class TagParams(BaseModel):
    """
    Specifies the tag vectors used to exclude EBS volumes attached to EC2 instances at global and object level. Contains two vectors: exclusion and inclusion. E.g., {exclusionTagArray: [(K1, V1),  (K2, V2)], inclusionTagArray: [(K3, V3)]} => This will exclude a particular volume iff it has all the tags in exclusionTagArray((K1, V1),  (K2, V2)) and has none of the tags in the inclusionTagArray((K3, V3)).
    """ # noqa: E501
    exclusion_tag_array: Optional[List[EBSTag]] = Field(default=None, description="Array which contains tags for AND exclusion. E.g., exclusionTagArray: [(K1, V1),  (K2, V2)] => This will exclude a particular volume iff it has both these tags.", alias="exclusionTagArray")
    inclusion_tag_array: Optional[List[EBSTag]] = Field(default=None, description="Array which contains tags for AND inclusion. E.g., inclusionTagArray: [(K3, V3),  (K4, V4)] => This will exclude a particular volume iff it does not have both these tags.", alias="inclusionTagArray")
    __properties: ClassVar[List[str]] = ["exclusionTagArray", "inclusionTagArray"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TagParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in exclusion_tag_array (list)
        _items = []
        if self.exclusion_tag_array:
            for _item_exclusion_tag_array in self.exclusion_tag_array:
                if _item_exclusion_tag_array:
                    _items.append(_item_exclusion_tag_array.to_dict())
            _dict['exclusionTagArray'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in inclusion_tag_array (list)
        _items = []
        if self.inclusion_tag_array:
            for _item_inclusion_tag_array in self.inclusion_tag_array:
                if _item_inclusion_tag_array:
                    _items.append(_item_inclusion_tag_array.to_dict())
            _dict['inclusionTagArray'] = _items
        # set to None if exclusion_tag_array (nullable) is None
        # and model_fields_set contains the field
        if self.exclusion_tag_array is None and "exclusion_tag_array" in self.model_fields_set:
            _dict['exclusionTagArray'] = None

        # set to None if inclusion_tag_array (nullable) is None
        # and model_fields_set contains the field
        if self.inclusion_tag_array is None and "inclusion_tag_array" in self.model_fields_set:
            _dict['inclusionTagArray'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TagParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "exclusionTagArray": [EBSTag.from_dict(_item) for _item in obj["exclusionTagArray"]] if obj.get("exclusionTagArray") is not None else None,
            "inclusionTagArray": [EBSTag.from_dict(_item) for _item in obj["inclusionTagArray"]] if obj.get("inclusionTagArray") is not None else None
        })
        return _obj


