# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from cohesity_sdk.cluster.models.update_archival_snapshot_config import UpdateArchivalSnapshotConfig
from cohesity_sdk.cluster.models.update_local_snapshot_config import UpdateLocalSnapshotConfig
from cohesity_sdk.cluster.models.update_replication_snapshot_config import UpdateReplicationSnapshotConfig
from typing import Set
from typing_extensions import Self

class UpdateProtectionGroupRunParams(BaseModel):
    """
    Specifies the params to update a Protection Group Run.
    """ # noqa: E501
    archival_snapshot_config: Optional[UpdateArchivalSnapshotConfig] = Field(default=None, alias="archivalSnapshotConfig")
    local_snapshot_config: Optional[UpdateLocalSnapshotConfig] = Field(default=None, alias="localSnapshotConfig")
    replication_snapshot_config: Optional[UpdateReplicationSnapshotConfig] = Field(default=None, alias="replicationSnapshotConfig")
    run_id: Optional[Annotated[str, Field(strict=True)]] = Field(description="Specifies a unique Protection Group Run id.", alias="runId")
    __properties: ClassVar[List[str]] = ["archivalSnapshotConfig", "localSnapshotConfig", "replicationSnapshotConfig", "runId"]

    @field_validator('run_id')
    def run_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d+:\d+$", value):
            raise ValueError(r"must validate the regular expression /^\d+:\d+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateProtectionGroupRunParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of archival_snapshot_config
        if self.archival_snapshot_config:
            _dict['archivalSnapshotConfig'] = self.archival_snapshot_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of local_snapshot_config
        if self.local_snapshot_config:
            _dict['localSnapshotConfig'] = self.local_snapshot_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of replication_snapshot_config
        if self.replication_snapshot_config:
            _dict['replicationSnapshotConfig'] = self.replication_snapshot_config.to_dict()
        # set to None if run_id (nullable) is None
        # and model_fields_set contains the field
        if self.run_id is None and "run_id" in self.model_fields_set:
            _dict['runId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateProtectionGroupRunParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "archivalSnapshotConfig": UpdateArchivalSnapshotConfig.from_dict(obj["archivalSnapshotConfig"]) if obj.get("archivalSnapshotConfig") is not None else None,
            "localSnapshotConfig": UpdateLocalSnapshotConfig.from_dict(obj["localSnapshotConfig"]) if obj.get("localSnapshotConfig") is not None else None,
            "replicationSnapshotConfig": UpdateReplicationSnapshotConfig.from_dict(obj["replicationSnapshotConfig"]) if obj.get("replicationSnapshotConfig") is not None else None,
            "runId": obj.get("runId")
        })
        return _obj


