# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from cohesity_sdk.cluster.models.update_protection_group_run_params import UpdateProtectionGroupRunParams
from typing import Set
from typing_extensions import Self

class UpdateProtectionGroupRunRequestBody(BaseModel):
    """
    Specifies the params to update a list of Protection Group Runs.
    """ # noqa: E501
    update_protection_group_run_params: Optional[Annotated[List[UpdateProtectionGroupRunParams], Field(min_length=1)]] = Field(alias="updateProtectionGroupRunParams")
    __properties: ClassVar[List[str]] = ["updateProtectionGroupRunParams"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateProtectionGroupRunRequestBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in update_protection_group_run_params (list)
        _items = []
        if self.update_protection_group_run_params:
            for _item_update_protection_group_run_params in self.update_protection_group_run_params:
                if _item_update_protection_group_run_params:
                    _items.append(_item_update_protection_group_run_params.to_dict())
            _dict['updateProtectionGroupRunParams'] = _items
        # set to None if update_protection_group_run_params (nullable) is None
        # and model_fields_set contains the field
        if self.update_protection_group_run_params is None and "update_protection_group_run_params" in self.model_fields_set:
            _dict['updateProtectionGroupRunParams'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateProtectionGroupRunRequestBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "updateProtectionGroupRunParams": [UpdateProtectionGroupRunParams.from_dict(_item) for _item in obj["updateProtectionGroupRunParams"]] if obj.get("updateProtectionGroupRunParams") is not None else None
        })
        return _obj


