# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.cluster.models.vmware_object_enable_sql_protection_params import VmwareObjectEnableSqlProtectionParams
from typing import Set
from typing_extensions import Self

class VmwareObjectEnableAppProtectionParams(BaseModel):
    """
    Specifies the parameters to enable app protection on VMware.
    """ # noqa: E501
    app_type: Optional[StrictStr] = Field(description="Specifies the app from which protection must be enabled.", alias="appType")
    enable_sql_protection_params: Optional[VmwareObjectEnableSqlProtectionParams] = Field(default=None, alias="enableSqlProtectionParams")
    __properties: ClassVar[List[str]] = ["appType", "enableSqlProtectionParams"]

    @field_validator('app_type')
    def app_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kSQL', 'kOracle', 'kAD', 'kExchange']):
            raise ValueError("must be one of enum values ('kSQL', 'kOracle', 'kAD', 'kExchange')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VmwareObjectEnableAppProtectionParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of enable_sql_protection_params
        if self.enable_sql_protection_params:
            _dict['enableSqlProtectionParams'] = self.enable_sql_protection_params.to_dict()
        # set to None if app_type (nullable) is None
        # and model_fields_set contains the field
        if self.app_type is None and "app_type" in self.model_fields_set:
            _dict['appType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VmwareObjectEnableAppProtectionParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "appType": obj.get("appType"),
            "enableSqlProtectionParams": VmwareObjectEnableSqlProtectionParams.from_dict(obj["enableSqlProtectionParams"]) if obj.get("enableSqlProtectionParams") is not None else None
        })
        return _obj


