# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class WormProperties(BaseModel):
    """
    Specifies the WORM related properties for this archive.
    """ # noqa: E501
    is_archive_worm_compliant: Optional[StrictBool] = Field(default=None, description="Specifies whether this archive run is WORM compliant", alias="isArchiveWormCompliant")
    worm_expiry_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the time at which the WORM protection expires.", alias="wormExpiryTimeUsecs")
    worm_non_compliance_reason: Optional[StrictStr] = Field(default=None, description="Specifies reason of archive not being worm compliant.", alias="wormNonComplianceReason")
    __properties: ClassVar[List[str]] = ["isArchiveWormCompliant", "wormExpiryTimeUsecs", "wormNonComplianceReason"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WormProperties from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if is_archive_worm_compliant (nullable) is None
        # and model_fields_set contains the field
        if self.is_archive_worm_compliant is None and "is_archive_worm_compliant" in self.model_fields_set:
            _dict['isArchiveWormCompliant'] = None

        # set to None if worm_expiry_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.worm_expiry_time_usecs is None and "worm_expiry_time_usecs" in self.model_fields_set:
            _dict['wormExpiryTimeUsecs'] = None

        # set to None if worm_non_compliance_reason (nullable) is None
        # and model_fields_set contains the field
        if self.worm_non_compliance_reason is None and "worm_non_compliance_reason" in self.model_fields_set:
            _dict['wormNonComplianceReason'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WormProperties from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "isArchiveWormCompliant": obj.get("isArchiveWormCompliant"),
            "wormExpiryTimeUsecs": obj.get("wormExpiryTimeUsecs"),
            "wormNonComplianceReason": obj.get("wormNonComplianceReason")
        })
        return _obj


