# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.active_directory import ActiveDirectory
from typing import Set
from typing_extensions import Self

class ActiveDirectories(BaseModel):
    """
    Response of Active Directories.
    """ # noqa: E501
    active_directories: Optional[List[ActiveDirectory]] = Field(default=None, description="A list of Active Directories.", alias="activeDirectories")
    __properties: ClassVar[List[str]] = ["activeDirectories"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ActiveDirectories from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in active_directories (list)
        _items = []
        if self.active_directories:
            for _item_active_directories in self.active_directories:
                if _item_active_directories:
                    _items.append(_item_active_directories.to_dict())
            _dict['activeDirectories'] = _items
        # set to None if active_directories (nullable) is None
        # and model_fields_set contains the field
        if self.active_directories is None and "active_directories" in self.model_fields_set:
            _dict['activeDirectories'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ActiveDirectories from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "activeDirectories": [ActiveDirectory.from_dict(_item) for _item in obj["activeDirectories"]] if obj.get("activeDirectories") is not None else None
        })
        return _obj


