# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class AlertDocument(BaseModel):
    """
    Specifies the fields of alert document.
    """ # noqa: E501
    alert_cause: Optional[StrictStr] = Field(default=None, description="Specifies the cause of alert.", alias="alertCause")
    alert_description: Optional[StrictStr] = Field(default=None, description="Specifies the description of alert.", alias="alertDescription")
    alert_help_text: Optional[StrictStr] = Field(default=None, description="Specifies the help text for alert.", alias="alertHelpText")
    alert_name: Optional[StrictStr] = Field(default=None, description="Specifies the name of alert.", alias="alertName")
    __properties: ClassVar[List[str]] = ["alertCause", "alertDescription", "alertHelpText", "alertName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AlertDocument from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if alert_cause (nullable) is None
        # and model_fields_set contains the field
        if self.alert_cause is None and "alert_cause" in self.model_fields_set:
            _dict['alertCause'] = None

        # set to None if alert_description (nullable) is None
        # and model_fields_set contains the field
        if self.alert_description is None and "alert_description" in self.model_fields_set:
            _dict['alertDescription'] = None

        # set to None if alert_help_text (nullable) is None
        # and model_fields_set contains the field
        if self.alert_help_text is None and "alert_help_text" in self.model_fields_set:
            _dict['alertHelpText'] = None

        # set to None if alert_name (nullable) is None
        # and model_fields_set contains the field
        if self.alert_name is None and "alert_name" in self.model_fields_set:
            _dict['alertName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AlertDocument from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "alertCause": obj.get("alertCause"),
            "alertDescription": obj.get("alertDescription"),
            "alertHelpText": obj.get("alertHelpText"),
            "alertName": obj.get("alertName")
        })
        return _obj


