# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.archival_target import ArchivalTarget
from typing import Set
from typing_extensions import Self

class ArchivalCopy(BaseModel):
    """
    Specifies the information about archival snapshot.
    """ # noqa: E501
    archival_target: Optional[ArchivalTarget] = Field(default=None, alias="archivalTarget")
    creation_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the creation time of archival snapshot.", alias="creationTimeUsecs")
    global_vault_id: Optional[StrictStr] = Field(default=None, description="Specifies the global vault id of the archival snapshot.", alias="globalVaultId")
    is_r_paas: Optional[StrictBool] = Field(default=None, description="Specifies whether this archival location is RPaas.", alias="isRPaas")
    rpaas_region: Optional[StrictStr] = Field(default=None, description="If the location is RPaas then this specifies the region.", alias="rpaasRegion")
    snapshot_id: Optional[StrictStr] = Field(default=None, description="Snapshot id of the snapshot corresponding to the archival copy of this backup run.", alias="snapshotId")
    status: Optional[StrictStr] = Field(default=None, description="Specifies the status of the archival snapshot.")
    __properties: ClassVar[List[str]] = ["archivalTarget", "creationTimeUsecs", "globalVaultId", "isRPaas", "rpaasRegion", "snapshotId", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ArchivalCopy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of archival_target
        if self.archival_target:
            _dict['archivalTarget'] = self.archival_target.to_dict()
        # set to None if creation_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.creation_time_usecs is None and "creation_time_usecs" in self.model_fields_set:
            _dict['creationTimeUsecs'] = None

        # set to None if global_vault_id (nullable) is None
        # and model_fields_set contains the field
        if self.global_vault_id is None and "global_vault_id" in self.model_fields_set:
            _dict['globalVaultId'] = None

        # set to None if is_r_paas (nullable) is None
        # and model_fields_set contains the field
        if self.is_r_paas is None and "is_r_paas" in self.model_fields_set:
            _dict['isRPaas'] = None

        # set to None if rpaas_region (nullable) is None
        # and model_fields_set contains the field
        if self.rpaas_region is None and "rpaas_region" in self.model_fields_set:
            _dict['rpaasRegion'] = None

        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ArchivalCopy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "archivalTarget": ArchivalTarget.from_dict(obj["archivalTarget"]) if obj.get("archivalTarget") is not None else None,
            "creationTimeUsecs": obj.get("creationTimeUsecs"),
            "globalVaultId": obj.get("globalVaultId"),
            "isRPaas": obj.get("isRPaas"),
            "rpaasRegion": obj.get("rpaasRegion"),
            "snapshotId": obj.get("snapshotId"),
            "status": obj.get("status")
        })
        return _obj


