# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class ArchivalMediaInfo(BaseModel):
    """
    Specifies the media information in QStar Archival.
    """ # noqa: E501
    barcode: Optional[StrictStr] = Field(default=None, description="Specifies a unique identifier for the media.")
    is_online: Optional[StrictBool] = Field(default=None, description="Specifies a flag that indicates if the media is online or offline. Offline media must be manually loaded into the media library before a recovery can occur.", alias="isOnline")
    location: Optional[StrictStr] = Field(default=None, description="Specifies the location of the offline media as recorded by the backup administrator using media management software.")
    __properties: ClassVar[List[str]] = ["barcode", "isOnline", "location"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ArchivalMediaInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "barcode",
            "location",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if barcode (nullable) is None
        # and model_fields_set contains the field
        if self.barcode is None and "barcode" in self.model_fields_set:
            _dict['barcode'] = None

        # set to None if is_online (nullable) is None
        # and model_fields_set contains the field
        if self.is_online is None and "is_online" in self.model_fields_set:
            _dict['isOnline'] = None

        # set to None if location (nullable) is None
        # and model_fields_set contains the field
        if self.location is None and "location" in self.model_fields_set:
            _dict['location'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ArchivalMediaInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "barcode": obj.get("barcode"),
            "isOnline": obj.get("isOnline"),
            "location": obj.get("location")
        })
        return _obj


