# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.archival_data_stats import ArchivalDataStats
from cohesity_sdk.helios.models.archival_target_tier_info import ArchivalTargetTierInfo
from cohesity_sdk.helios.models.data_lock_constraints import DataLockConstraints
from cohesity_sdk.helios.models.worm_properties import WormProperties
from typing import Set
from typing_extensions import Self

class ArchivalTargetResult(BaseModel):
    """
    Archival result for an archival target.
    """ # noqa: E501
    archival_task_id: Optional[StrictStr] = Field(default=None, description="Specifies the archival task id. This is a protection group UID which only applies when archival type is 'Tape'.", alias="archivalTaskId")
    ownership_context: Optional[StrictStr] = Field(default=None, description="Specifies the ownership context for the target.", alias="ownershipContext")
    target_id: Optional[StrictInt] = Field(default=None, description="Specifies the archival target ID.", alias="targetId")
    target_name: Optional[StrictStr] = Field(default=None, description="Specifies the archival target name.", alias="targetName")
    target_type: Optional[StrictStr] = Field(default=None, description="Specifies the archival target type.", alias="targetType")
    tier_settings: Optional[ArchivalTargetTierInfo] = Field(default=None, alias="tierSettings")
    usage_type: Optional[StrictStr] = Field(default=None, description="Specifies the usage type for the target.", alias="usageType")
    cancelled_app_objects_count: Optional[StrictInt] = Field(default=None, description="Specifies the count of app objects for which backup was cancelled.", alias="cancelledAppObjectsCount")
    cancelled_objects_count: Optional[StrictInt] = Field(default=None, description="Specifies the count of objects for which backup was cancelled.", alias="cancelledObjectsCount")
    data_lock_constraints: Optional[DataLockConstraints] = Field(default=None, alias="dataLockConstraints")
    end_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the end time of replication run in Unix epoch Timestamp(in microseconds) for an archival target.", alias="endTimeUsecs")
    expiry_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the expiry time of attempt in Unix epoch Timestamp (in microseconds).", alias="expiryTimeUsecs")
    failed_app_objects_count: Optional[StrictInt] = Field(default=None, description="Specifies the count of app objects for which backup failed.", alias="failedAppObjectsCount")
    failed_objects_count: Optional[StrictInt] = Field(default=None, description="Specifies the count of objects for which backup failed.", alias="failedObjectsCount")
    indexing_task_id: Optional[StrictStr] = Field(default=None, description="Progress monitor task for indexing.", alias="indexingTaskId")
    is_cad_archive: Optional[StrictBool] = Field(default=None, description="Whether this is CAD archive or not", alias="isCadArchive")
    is_forever_incremental: Optional[StrictBool] = Field(default=None, description="Whether this is forever incremental or not", alias="isForeverIncremental")
    is_incremental: Optional[StrictBool] = Field(default=None, description="Whether this is an incremental archive. If set to true, this is an incremental archive, otherwise this is a full archive.", alias="isIncremental")
    is_manually_deleted: Optional[StrictBool] = Field(default=None, description="Specifies whether the snapshot is deleted manually.", alias="isManuallyDeleted")
    is_sla_violated: Optional[StrictBool] = Field(default=None, description="Indicated if SLA has been violated for this run.", alias="isSlaViolated")
    message: Optional[StrictStr] = Field(default=None, description="Message about the archival run.")
    on_legal_hold: Optional[StrictBool] = Field(default=None, description="Specifies the legal hold status for a archival target.", alias="onLegalHold")
    progress_task_id: Optional[StrictStr] = Field(default=None, description="Progress monitor task id for archival.", alias="progressTaskId")
    queued_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the time when the archival is queued for schedule in Unix epoch Timestamp(in microseconds) for a target.", alias="queuedTimeUsecs")
    run_type: Optional[StrictStr] = Field(default=None, description="Type of Protection Group run. 'kRegular' indicates an incremental (CBT) backup. Incremental backups utilizing CBT (if supported) are captured of the target protection objects. The first run of a kRegular schedule captures all the blocks. 'kFull' indicates a full (no CBT) backup. A complete backup (all blocks) of the target protection objects are always captured and Change Block Tracking (CBT) is not utilized. 'kLog' indicates a Database Log backup. Capture the database transaction logs to allow rolling back to a specific point in time. 'kSystem' indicates system volume backup. It produces an image for bare metal recovery.", alias="runType")
    snapshot_id: Optional[StrictStr] = Field(default=None, description="Snapshot id for a successful snapshot. This field will not be set if the archival Run fails to take the snapshot.", alias="snapshotId")
    start_time_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the start time of replication run in Unix epoch Timestamp(in microseconds) for an archival target.", alias="startTimeUsecs")
    stats: Optional[ArchivalDataStats] = None
    stats_task_id: Optional[StrictStr] = Field(default=None, description="Run Stats task id for archival.", alias="statsTaskId")
    status: Optional[StrictStr] = Field(default=None, description="Status of the replication run for an archival target. 'Running' indicates that the run is still running. 'Canceled' indicates that the run has been canceled. 'Canceling' indicates that the run is in the process of being canceled. 'Paused' indicates that the ongoing run has been paused. 'Failed' indicates that the run has failed. 'Missed' indicates that the run was unable to take place at the scheduled time because the previous run was still happening. 'Succeeded' indicates that the run has finished successfully. 'SucceededWithWarning' indicates that the run finished successfully, but there were some warning messages. 'Skipped' indicates that the run was skipped.")
    successful_app_objects_count: Optional[StrictInt] = Field(default=None, description="Specifies the count of app objects for which backup was successful.", alias="successfulAppObjectsCount")
    successful_objects_count: Optional[StrictInt] = Field(default=None, description="Specifies the count of objects for which backup was successful.", alias="successfulObjectsCount")
    worm_properties: Optional[WormProperties] = Field(default=None, alias="wormProperties")
    __properties: ClassVar[List[str]] = ["archivalTaskId", "ownershipContext", "targetId", "targetName", "targetType", "tierSettings", "usageType", "cancelledAppObjectsCount", "cancelledObjectsCount", "dataLockConstraints", "endTimeUsecs", "expiryTimeUsecs", "failedAppObjectsCount", "failedObjectsCount", "indexingTaskId", "isCadArchive", "isForeverIncremental", "isIncremental", "isManuallyDeleted", "isSlaViolated", "message", "onLegalHold", "progressTaskId", "queuedTimeUsecs", "runType", "snapshotId", "startTimeUsecs", "stats", "statsTaskId", "status", "successfulAppObjectsCount", "successfulObjectsCount", "wormProperties"]

    @field_validator('ownership_context')
    def ownership_context_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Local', 'FortKnox']):
            raise ValueError("must be one of enum values ('Local', 'FortKnox')")
        return value

    @field_validator('target_type')
    def target_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Tape', 'Cloud', 'Nas']):
            raise ValueError("must be one of enum values ('Tape', 'Cloud', 'Nas')")
        return value

    @field_validator('usage_type')
    def usage_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Archival', 'Tiering', 'Rpaas']):
            raise ValueError("must be one of enum values ('Archival', 'Tiering', 'Rpaas')")
        return value

    @field_validator('run_type')
    def run_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kRegular', 'kFull', 'kLog', 'kSystem', 'kHydrateCDP', 'kStorageArraySnapshot']):
            raise ValueError("must be one of enum values ('kRegular', 'kFull', 'kLog', 'kSystem', 'kHydrateCDP', 'kStorageArraySnapshot')")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Accepted', 'Running', 'Canceled', 'Canceling', 'Failed', 'Missed', 'Succeeded', 'SucceededWithWarning', 'OnHold', 'Finalizing', 'Skipped', 'Paused']):
            raise ValueError("must be one of enum values ('Accepted', 'Running', 'Canceled', 'Canceling', 'Failed', 'Missed', 'Succeeded', 'SucceededWithWarning', 'OnHold', 'Finalizing', 'Skipped', 'Paused')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ArchivalTargetResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of tier_settings
        if self.tier_settings:
            _dict['tierSettings'] = self.tier_settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data_lock_constraints
        if self.data_lock_constraints:
            _dict['dataLockConstraints'] = self.data_lock_constraints.to_dict()
        # override the default output from pydantic by calling `to_dict()` of stats
        if self.stats:
            _dict['stats'] = self.stats.to_dict()
        # override the default output from pydantic by calling `to_dict()` of worm_properties
        if self.worm_properties:
            _dict['wormProperties'] = self.worm_properties.to_dict()
        # set to None if archival_task_id (nullable) is None
        # and model_fields_set contains the field
        if self.archival_task_id is None and "archival_task_id" in self.model_fields_set:
            _dict['archivalTaskId'] = None

        # set to None if ownership_context (nullable) is None
        # and model_fields_set contains the field
        if self.ownership_context is None and "ownership_context" in self.model_fields_set:
            _dict['ownershipContext'] = None

        # set to None if target_id (nullable) is None
        # and model_fields_set contains the field
        if self.target_id is None and "target_id" in self.model_fields_set:
            _dict['targetId'] = None

        # set to None if target_name (nullable) is None
        # and model_fields_set contains the field
        if self.target_name is None and "target_name" in self.model_fields_set:
            _dict['targetName'] = None

        # set to None if target_type (nullable) is None
        # and model_fields_set contains the field
        if self.target_type is None and "target_type" in self.model_fields_set:
            _dict['targetType'] = None

        # set to None if usage_type (nullable) is None
        # and model_fields_set contains the field
        if self.usage_type is None and "usage_type" in self.model_fields_set:
            _dict['usageType'] = None

        # set to None if cancelled_app_objects_count (nullable) is None
        # and model_fields_set contains the field
        if self.cancelled_app_objects_count is None and "cancelled_app_objects_count" in self.model_fields_set:
            _dict['cancelledAppObjectsCount'] = None

        # set to None if cancelled_objects_count (nullable) is None
        # and model_fields_set contains the field
        if self.cancelled_objects_count is None and "cancelled_objects_count" in self.model_fields_set:
            _dict['cancelledObjectsCount'] = None

        # set to None if end_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.end_time_usecs is None and "end_time_usecs" in self.model_fields_set:
            _dict['endTimeUsecs'] = None

        # set to None if expiry_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.expiry_time_usecs is None and "expiry_time_usecs" in self.model_fields_set:
            _dict['expiryTimeUsecs'] = None

        # set to None if failed_app_objects_count (nullable) is None
        # and model_fields_set contains the field
        if self.failed_app_objects_count is None and "failed_app_objects_count" in self.model_fields_set:
            _dict['failedAppObjectsCount'] = None

        # set to None if failed_objects_count (nullable) is None
        # and model_fields_set contains the field
        if self.failed_objects_count is None and "failed_objects_count" in self.model_fields_set:
            _dict['failedObjectsCount'] = None

        # set to None if indexing_task_id (nullable) is None
        # and model_fields_set contains the field
        if self.indexing_task_id is None and "indexing_task_id" in self.model_fields_set:
            _dict['indexingTaskId'] = None

        # set to None if is_cad_archive (nullable) is None
        # and model_fields_set contains the field
        if self.is_cad_archive is None and "is_cad_archive" in self.model_fields_set:
            _dict['isCadArchive'] = None

        # set to None if is_forever_incremental (nullable) is None
        # and model_fields_set contains the field
        if self.is_forever_incremental is None and "is_forever_incremental" in self.model_fields_set:
            _dict['isForeverIncremental'] = None

        # set to None if is_incremental (nullable) is None
        # and model_fields_set contains the field
        if self.is_incremental is None and "is_incremental" in self.model_fields_set:
            _dict['isIncremental'] = None

        # set to None if is_manually_deleted (nullable) is None
        # and model_fields_set contains the field
        if self.is_manually_deleted is None and "is_manually_deleted" in self.model_fields_set:
            _dict['isManuallyDeleted'] = None

        # set to None if is_sla_violated (nullable) is None
        # and model_fields_set contains the field
        if self.is_sla_violated is None and "is_sla_violated" in self.model_fields_set:
            _dict['isSlaViolated'] = None

        # set to None if message (nullable) is None
        # and model_fields_set contains the field
        if self.message is None and "message" in self.model_fields_set:
            _dict['message'] = None

        # set to None if on_legal_hold (nullable) is None
        # and model_fields_set contains the field
        if self.on_legal_hold is None and "on_legal_hold" in self.model_fields_set:
            _dict['onLegalHold'] = None

        # set to None if progress_task_id (nullable) is None
        # and model_fields_set contains the field
        if self.progress_task_id is None and "progress_task_id" in self.model_fields_set:
            _dict['progressTaskId'] = None

        # set to None if queued_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.queued_time_usecs is None and "queued_time_usecs" in self.model_fields_set:
            _dict['queuedTimeUsecs'] = None

        # set to None if run_type (nullable) is None
        # and model_fields_set contains the field
        if self.run_type is None and "run_type" in self.model_fields_set:
            _dict['runType'] = None

        # set to None if snapshot_id (nullable) is None
        # and model_fields_set contains the field
        if self.snapshot_id is None and "snapshot_id" in self.model_fields_set:
            _dict['snapshotId'] = None

        # set to None if start_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.start_time_usecs is None and "start_time_usecs" in self.model_fields_set:
            _dict['startTimeUsecs'] = None

        # set to None if stats_task_id (nullable) is None
        # and model_fields_set contains the field
        if self.stats_task_id is None and "stats_task_id" in self.model_fields_set:
            _dict['statsTaskId'] = None

        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        # set to None if successful_app_objects_count (nullable) is None
        # and model_fields_set contains the field
        if self.successful_app_objects_count is None and "successful_app_objects_count" in self.model_fields_set:
            _dict['successfulAppObjectsCount'] = None

        # set to None if successful_objects_count (nullable) is None
        # and model_fields_set contains the field
        if self.successful_objects_count is None and "successful_objects_count" in self.model_fields_set:
            _dict['successfulObjectsCount'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ArchivalTargetResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "archivalTaskId": obj.get("archivalTaskId"),
            "ownershipContext": obj.get("ownershipContext"),
            "targetId": obj.get("targetId"),
            "targetName": obj.get("targetName"),
            "targetType": obj.get("targetType"),
            "tierSettings": ArchivalTargetTierInfo.from_dict(obj["tierSettings"]) if obj.get("tierSettings") is not None else None,
            "usageType": obj.get("usageType"),
            "cancelledAppObjectsCount": obj.get("cancelledAppObjectsCount"),
            "cancelledObjectsCount": obj.get("cancelledObjectsCount"),
            "dataLockConstraints": DataLockConstraints.from_dict(obj["dataLockConstraints"]) if obj.get("dataLockConstraints") is not None else None,
            "endTimeUsecs": obj.get("endTimeUsecs"),
            "expiryTimeUsecs": obj.get("expiryTimeUsecs"),
            "failedAppObjectsCount": obj.get("failedAppObjectsCount"),
            "failedObjectsCount": obj.get("failedObjectsCount"),
            "indexingTaskId": obj.get("indexingTaskId"),
            "isCadArchive": obj.get("isCadArchive"),
            "isForeverIncremental": obj.get("isForeverIncremental"),
            "isIncremental": obj.get("isIncremental"),
            "isManuallyDeleted": obj.get("isManuallyDeleted"),
            "isSlaViolated": obj.get("isSlaViolated"),
            "message": obj.get("message"),
            "onLegalHold": obj.get("onLegalHold"),
            "progressTaskId": obj.get("progressTaskId"),
            "queuedTimeUsecs": obj.get("queuedTimeUsecs"),
            "runType": obj.get("runType"),
            "snapshotId": obj.get("snapshotId"),
            "startTimeUsecs": obj.get("startTimeUsecs"),
            "stats": ArchivalDataStats.from_dict(obj["stats"]) if obj.get("stats") is not None else None,
            "statsTaskId": obj.get("statsTaskId"),
            "status": obj.get("status"),
            "successfulAppObjectsCount": obj.get("successfulAppObjectsCount"),
            "successfulObjectsCount": obj.get("successfulObjectsCount"),
            "wormProperties": WormProperties.from_dict(obj["wormProperties"]) if obj.get("wormProperties") is not None else None
        })
        return _obj


