# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.recover_aws_vm_new_source_config import RecoverAwsVmNewSourceConfig
from typing import Set
from typing_extensions import Self

class AwsVmRecoveryTargetConfig(BaseModel):
    """
    Specifies the target object parameters to recover AWS vms.
    """ # noqa: E501
    new_source_config: Optional[RecoverAwsVmNewSourceConfig] = Field(default=None, description="Specifies the new destination Source configuration parameters where the VMs will be recovered. This is mandatory if recoverToNewSource is set to true.", alias="newSourceConfig")
    recover_to_new_source: StrictBool = Field(description="Specifies the parameter whether the recovery should be performed to a new or an existing Source Target.", alias="recoverToNewSource")
    __properties: ClassVar[List[str]] = ["newSourceConfig", "recoverToNewSource"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AwsVmRecoveryTargetConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of new_source_config
        if self.new_source_config:
            _dict['newSourceConfig'] = self.new_source_config.to_dict()
        # set to None if new_source_config (nullable) is None
        # and model_fields_set contains the field
        if self.new_source_config is None and "new_source_config" in self.model_fields_set:
            _dict['newSourceConfig'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AwsVmRecoveryTargetConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "newSourceConfig": RecoverAwsVmNewSourceConfig.from_dict(obj["newSourceConfig"]) if obj.get("newSourceConfig") is not None else None,
            "recoverToNewSource": obj.get("recoverToNewSource")
        })
        return _obj


