# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class BackendUsage(BaseModel):
    """
    Specifies the TiB usage statistics.
    """ # noqa: E501
    azure_current_storage_account_usage_bytes: Optional[StrictInt] = Field(default=None, description="The current azure storage account usage from the start of the month.", alias="azureCurrentStorageAccountUsageBytes")
    current_s3_glacier_usage_bytes: Optional[StrictInt] = Field(default=None, description="The current s3 glacier usage from the start of the month.", alias="currentS3GlacierUsageBytes")
    current_s3_usage_bytes: Optional[StrictInt] = Field(default=None, description="The current s3 usage from the start of the month.", alias="currentS3UsageBytes")
    region_id: Optional[StrictStr] = Field(default=None, description="The current region for which usage is calculated.", alias="regionId")
    __properties: ClassVar[List[str]] = ["azureCurrentStorageAccountUsageBytes", "currentS3GlacierUsageBytes", "currentS3UsageBytes", "regionId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BackendUsage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BackendUsage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "azureCurrentStorageAccountUsageBytes": obj.get("azureCurrentStorageAccountUsageBytes"),
            "currentS3GlacierUsageBytes": obj.get("currentS3GlacierUsageBytes"),
            "currentS3UsageBytes": obj.get("currentS3UsageBytes"),
            "regionId": obj.get("regionId")
        })
        return _obj


