# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.capacity_trend_datapoint import CapacityTrendDatapoint
from typing import Set
from typing_extensions import Self

class CapacityTrendAnalysis(BaseModel):
    """
    Capacity Trend analysis of the requested sources in the given time range.
    """ # noqa: E501
    data_point_vec: Optional[List[CapacityTrendDatapoint]] = Field(default=None, description="Vector of data points. Each data point contains statistics on analysis and downtiered data.", alias="dataPointVec")
    last_updated_time_usecs: Optional[StrictInt] = Field(default=None, description="Last updated time of capacity trend.", alias="lastUpdatedTimeUsecs")
    __properties: ClassVar[List[str]] = ["dataPointVec", "lastUpdatedTimeUsecs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CapacityTrendAnalysis from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in data_point_vec (list)
        _items = []
        if self.data_point_vec:
            for _item_data_point_vec in self.data_point_vec:
                if _item_data_point_vec:
                    _items.append(_item_data_point_vec.to_dict())
            _dict['dataPointVec'] = _items
        # set to None if data_point_vec (nullable) is None
        # and model_fields_set contains the field
        if self.data_point_vec is None and "data_point_vec" in self.model_fields_set:
            _dict['dataPointVec'] = None

        # set to None if last_updated_time_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.last_updated_time_usecs is None and "last_updated_time_usecs" in self.model_fields_set:
            _dict['lastUpdatedTimeUsecs'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CapacityTrendAnalysis from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dataPointVec": [CapacityTrendDatapoint.from_dict(_item) for _item in obj["dataPointVec"]] if obj.get("dataPointVec") is not None else None,
            "lastUpdatedTimeUsecs": obj.get("lastUpdatedTimeUsecs")
        })
        return _obj


