# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.capacity_trend_datapoint_stats import CapacityTrendDatapointStats
from typing import Set
from typing_extensions import Self

class CapacityTrendDatapoint(BaseModel):
    """
    A data point for the capacity trend analysis chart.
    """ # noqa: E501
    data_point_stats: Optional[List[CapacityTrendDatapointStats]] = Field(default=None, description="Specifies an array of tag and its corresponding statistic.", alias="dataPointStats")
    data_point_timestamp: Optional[StrictInt] = Field(default=None, description="Specifies the timestamp of this data point.", alias="dataPointTimestamp")
    error_messages: Optional[List[StrictStr]] = Field(default=None, description="Specifies error messages, if any error is encountered while fetching the datapoint stats.", alias="errorMessages")
    __properties: ClassVar[List[str]] = ["dataPointStats", "dataPointTimestamp", "errorMessages"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CapacityTrendDatapoint from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in data_point_stats (list)
        _items = []
        if self.data_point_stats:
            for _item_data_point_stats in self.data_point_stats:
                if _item_data_point_stats:
                    _items.append(_item_data_point_stats.to_dict())
            _dict['dataPointStats'] = _items
        # set to None if data_point_stats (nullable) is None
        # and model_fields_set contains the field
        if self.data_point_stats is None and "data_point_stats" in self.model_fields_set:
            _dict['dataPointStats'] = None

        # set to None if error_messages (nullable) is None
        # and model_fields_set contains the field
        if self.error_messages is None and "error_messages" in self.model_fields_set:
            _dict['errorMessages'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CapacityTrendDatapoint from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dataPointStats": [CapacityTrendDatapointStats.from_dict(_item) for _item in obj["dataPointStats"]] if obj.get("dataPointStats") is not None else None,
            "dataPointTimestamp": obj.get("dataPointTimestamp"),
            "errorMessages": obj.get("errorMessages")
        })
        return _obj


