# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.centrify_zone import CentrifyZone
from typing import Set
from typing_extensions import Self

class CentrifyZones(BaseModel):
    """
    Specifies a list of centrify zones for a domain.
    """ # noqa: E501
    centrify_zones: Optional[List[CentrifyZone]] = Field(default=None, description="Specifies a list of centrify zones for this domain.", alias="centrifyZones")
    domain_name: Optional[StrictStr] = Field(default=None, description="Specifies a domain name with these centrify zones.", alias="domainName")
    __properties: ClassVar[List[str]] = ["centrifyZones", "domainName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CentrifyZones from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in centrify_zones (list)
        _items = []
        if self.centrify_zones:
            for _item_centrify_zones in self.centrify_zones:
                if _item_centrify_zones:
                    _items.append(_item_centrify_zones.to_dict())
            _dict['centrifyZones'] = _items
        # set to None if centrify_zones (nullable) is None
        # and model_fields_set contains the field
        if self.centrify_zones is None and "centrify_zones" in self.model_fields_set:
            _dict['centrifyZones'] = None

        # set to None if domain_name (nullable) is None
        # and model_fields_set contains the field
        if self.domain_name is None and "domain_name" in self.model_fields_set:
            _dict['domainName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CentrifyZones from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "centrifyZones": [CentrifyZone.from_dict(_item) for _item in obj["centrifyZones"]] if obj.get("centrifyZones") is not None else None,
            "domainName": obj.get("domainName")
        })
        return _obj


