# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class ChassisInfo(BaseModel):
    """
    ChassisInfo is the struct for the Chassis.
    """ # noqa: E501
    chassis_id: Optional[StrictInt] = Field(default=None, description="ChassisId is a unique id assigned to the chassis.", alias="chassisId")
    chassis_name: Optional[StrictStr] = Field(default=None, description="ChassisName is the name of the chassis. This could be the chassis serial number by default.", alias="chassisName")
    chassis_serial: Optional[StrictStr] = Field(default=None, description="Chassis serial.", alias="chassisSerial")
    location: Optional[StrictStr] = Field(default=None, description="Location is the location of the chassis within the rack.")
    rack_id: Optional[StrictInt] = Field(default=None, description="Rack is the rack within which this chassis lives.", alias="rackId")
    __properties: ClassVar[List[str]] = ["chassisId", "chassisName", "chassisSerial", "location", "rackId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChassisInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if chassis_id (nullable) is None
        # and model_fields_set contains the field
        if self.chassis_id is None and "chassis_id" in self.model_fields_set:
            _dict['chassisId'] = None

        # set to None if chassis_name (nullable) is None
        # and model_fields_set contains the field
        if self.chassis_name is None and "chassis_name" in self.model_fields_set:
            _dict['chassisName'] = None

        # set to None if chassis_serial (nullable) is None
        # and model_fields_set contains the field
        if self.chassis_serial is None and "chassis_serial" in self.model_fields_set:
            _dict['chassisSerial'] = None

        # set to None if location (nullable) is None
        # and model_fields_set contains the field
        if self.location is None and "location" in self.model_fields_set:
            _dict['location'] = None

        # set to None if rack_id (nullable) is None
        # and model_fields_set contains the field
        if self.rack_id is None and "rack_id" in self.model_fields_set:
            _dict['rackId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChassisInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chassisId": obj.get("chassisId"),
            "chassisName": obj.get("chassisName"),
            "chassisSerial": obj.get("chassisSerial"),
            "location": obj.get("location"),
            "rackId": obj.get("rackId")
        })
        return _obj


