# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class CreateClientcsrResponseBody(BaseModel):
    """
    Specifies the response to creating the CSRs.
    """ # noqa: E501
    csr_client: Optional[StrictStr] = Field(default=None, description="Specifies the CSR generated for the client.", alias="csrClient")
    csr_server: Optional[StrictStr] = Field(default=None, description="Specifies the CSR generated for the server.", alias="csrServer")
    file_csr_client: Optional[StrictStr] = Field(default=None, description="Specifies the path to CSR generated for the client", alias="fileCsrClient")
    file_csr_server: Optional[StrictStr] = Field(default=None, description="Specifies the path to CSR generated for the server", alias="fileCsrServer")
    public_key_client: Optional[StrictStr] = Field(default=None, description="Specifies the public key generated for this CSR for the client.", alias="publicKeyClient")
    public_key_server: Optional[StrictStr] = Field(default=None, description="Specifies the public key generated for this CSR for the server.", alias="publicKeyServer")
    __properties: ClassVar[List[str]] = ["csrClient", "csrServer", "fileCsrClient", "fileCsrServer", "publicKeyClient", "publicKeyServer"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateClientcsrResponseBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if csr_client (nullable) is None
        # and model_fields_set contains the field
        if self.csr_client is None and "csr_client" in self.model_fields_set:
            _dict['csrClient'] = None

        # set to None if csr_server (nullable) is None
        # and model_fields_set contains the field
        if self.csr_server is None and "csr_server" in self.model_fields_set:
            _dict['csrServer'] = None

        # set to None if file_csr_client (nullable) is None
        # and model_fields_set contains the field
        if self.file_csr_client is None and "file_csr_client" in self.model_fields_set:
            _dict['fileCsrClient'] = None

        # set to None if file_csr_server (nullable) is None
        # and model_fields_set contains the field
        if self.file_csr_server is None and "file_csr_server" in self.model_fields_set:
            _dict['fileCsrServer'] = None

        # set to None if public_key_client (nullable) is None
        # and model_fields_set contains the field
        if self.public_key_client is None and "public_key_client" in self.model_fields_set:
            _dict['publicKeyClient'] = None

        # set to None if public_key_server (nullable) is None
        # and model_fields_set contains the field
        if self.public_key_server is None and "public_key_server" in self.model_fields_set:
            _dict['publicKeyServer'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateClientcsrResponseBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "csrClient": obj.get("csrClient"),
            "csrServer": obj.get("csrServer"),
            "fileCsrClient": obj.get("fileCsrClient"),
            "fileCsrServer": obj.get("fileCsrServer"),
            "publicKeyClient": obj.get("publicKeyClient"),
            "publicKeyServer": obj.get("publicKeyServer")
        })
        return _obj


