# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Set
from typing_extensions import Self

class DataPoint(BaseModel):
    """
    Specifies a data point.
    """ # noqa: E501
    double_value: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Specifies the data point value in double format.", alias="doubleValue")
    int64_value: Optional[StrictInt] = Field(default=None, description="Specifies the data point value in int64 format.", alias="int64Value")
    string_value: Optional[StrictStr] = Field(default=None, description="Specifies the data point value in string format.", alias="stringValue")
    timestamp_msecs: Optional[StrictInt] = Field(default=None, description="Specifies the timestamp of the data point.", alias="timestampMsecs")
    __properties: ClassVar[List[str]] = ["doubleValue", "int64Value", "stringValue", "timestampMsecs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataPoint from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if double_value (nullable) is None
        # and model_fields_set contains the field
        if self.double_value is None and "double_value" in self.model_fields_set:
            _dict['doubleValue'] = None

        # set to None if int64_value (nullable) is None
        # and model_fields_set contains the field
        if self.int64_value is None and "int64_value" in self.model_fields_set:
            _dict['int64Value'] = None

        # set to None if string_value (nullable) is None
        # and model_fields_set contains the field
        if self.string_value is None and "string_value" in self.model_fields_set:
            _dict['stringValue'] = None

        # set to None if timestamp_msecs (nullable) is None
        # and model_fields_set contains the field
        if self.timestamp_msecs is None and "timestamp_msecs" in self.model_fields_set:
            _dict['timestampMsecs'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataPoint from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "doubleValue": obj.get("doubleValue"),
            "int64Value": obj.get("int64Value"),
            "stringValue": obj.get("stringValue"),
            "timestampMsecs": obj.get("timestampMsecs")
        })
        return _obj


