# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.container_database_info import ContainerDatabaseInfo
from cohesity_sdk.helios.models.oracle_data_guard_info import OracleDataGuardInfo
from typing import Set
from typing_extensions import Self

class DatabaseEntityInfo(BaseModel):
    """
    Object details about Oracle database entity info.
    """ # noqa: E501
    container_database_info: Optional[ContainerDatabaseInfo] = Field(default=None, alias="containerDatabaseInfo")
    data_guard_info: Optional[OracleDataGuardInfo] = Field(default=None, alias="dataGuardInfo")
    db_type: Optional[StrictStr] = Field(default=None, description="Specifies database type of oracle database.", alias="dbType")
    __properties: ClassVar[List[str]] = ["containerDatabaseInfo", "dataGuardInfo", "dbType"]

    @field_validator('db_type')
    def db_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kSingleInstance', 'kRACDatabase']):
            raise ValueError("must be one of enum values ('kSingleInstance', 'kRACDatabase')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DatabaseEntityInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of container_database_info
        if self.container_database_info:
            _dict['containerDatabaseInfo'] = self.container_database_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data_guard_info
        if self.data_guard_info:
            _dict['dataGuardInfo'] = self.data_guard_info.to_dict()
        # set to None if db_type (nullable) is None
        # and model_fields_set contains the field
        if self.db_type is None and "db_type" in self.model_fields_set:
            _dict['dbType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DatabaseEntityInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "containerDatabaseInfo": ContainerDatabaseInfo.from_dict(obj["containerDatabaseInfo"]) if obj.get("containerDatabaseInfo") is not None else None,
            "dataGuardInfo": OracleDataGuardInfo.from_dict(obj["dataGuardInfo"]) if obj.get("dataGuardInfo") is not None else None,
            "dbType": obj.get("dbType")
        })
        return _obj


