# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.aws_entity_metadata import AwsEntityMetadata
from cohesity_sdk.helios.models.azure_entity_metadata import AzureEntityMetadata
from cohesity_sdk.helios.models.maintenance_mode_config import MaintenanceModeConfig
from typing import Set
from typing_extensions import Self

class EntityMetadataParams(BaseModel):
    """
    Specifies the parameters to associate metadata with entities in the entity hierarchy.
    """ # noqa: E501
    aws_params: Optional[AwsEntityMetadata] = Field(default=None, alias="awsParams")
    azure_params: Optional[AzureEntityMetadata] = Field(default=None, alias="azureParams")
    entity_id: StrictInt = Field(description="Specifies the entity id of the entity whose metadata is being updated.", alias="entityId")
    maintenance_mode_config: Optional[MaintenanceModeConfig] = Field(default=None, alias="maintenanceModeConfig")
    __properties: ClassVar[List[str]] = ["awsParams", "azureParams", "entityId", "maintenanceModeConfig"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EntityMetadataParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aws_params
        if self.aws_params:
            _dict['awsParams'] = self.aws_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of azure_params
        if self.azure_params:
            _dict['azureParams'] = self.azure_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of maintenance_mode_config
        if self.maintenance_mode_config:
            _dict['maintenanceModeConfig'] = self.maintenance_mode_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EntityMetadataParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "awsParams": AwsEntityMetadata.from_dict(obj["awsParams"]) if obj.get("awsParams") is not None else None,
            "azureParams": AzureEntityMetadata.from_dict(obj["azureParams"]) if obj.get("azureParams") is not None else None,
            "entityId": obj.get("entityId"),
            "maintenanceModeConfig": MaintenanceModeConfig.from_dict(obj["maintenanceModeConfig"]) if obj.get("maintenanceModeConfig") is not None else None
        })
        return _obj


