# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class ExpirationAction(BaseModel):
    """
    Specifies the Lifecycle current version ExpirationAction. Note: All the three fields are mutually exclusive to each other.
    """ # noqa: E501
    date_in_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the Timestamp in Usecs for the date when the object is subject to the rule.", alias="dateInUsecs")
    days: Optional[StrictInt] = Field(default=None, description="Specifies the Lifetime in days of the objects that are subject to the rule.")
    expired_object_delete_marker: Optional[StrictBool] = Field(default=None, description="Specifies whether Amazon S3 will remove a delete marker with no non-current versions. If set, the delete marker will be expired.", alias="expiredObjectDeleteMarker")
    __properties: ClassVar[List[str]] = ["dateInUsecs", "days", "expiredObjectDeleteMarker"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExpirationAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if date_in_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.date_in_usecs is None and "date_in_usecs" in self.model_fields_set:
            _dict['dateInUsecs'] = None

        # set to None if days (nullable) is None
        # and model_fields_set contains the field
        if self.days is None and "days" in self.model_fields_set:
            _dict['days'] = None

        # set to None if expired_object_delete_marker (nullable) is None
        # and model_fields_set contains the field
        if self.expired_object_delete_marker is None and "expired_object_delete_marker" in self.model_fields_set:
            _dict['expiredObjectDeleteMarker'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExpirationAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dateInUsecs": obj.get("dateInUsecs"),
            "days": obj.get("days"),
            "expiredObjectDeleteMarker": obj.get("expiredObjectDeleteMarker")
        })
        return _obj


