# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.externally_triggered_sbt_params import ExternallyTriggeredSbtParams
from typing import Set
from typing_extensions import Self

class ExternallyTriggeredJobParams(BaseModel):
    """
    Specifies the externally triggered job paramters.
    """ # noqa: E501
    client_type: Optional[StrictStr] = Field(default=None, description="Specifies the client type of the externally triggered backup job.", alias="clientType")
    sbt_params: Optional[ExternallyTriggeredSbtParams] = Field(default=None, description="Specifies the SBT parameters for the externally triggered backup job.", alias="sbtParams")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Specifies all the tags of the externally triggered job.")
    __properties: ClassVar[List[str]] = ["clientType", "sbtParams", "tags"]

    @field_validator('client_type')
    def client_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Generic', 'SBT']):
            raise ValueError("must be one of enum values ('Generic', 'SBT')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExternallyTriggeredJobParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sbt_params
        if self.sbt_params:
            _dict['sbtParams'] = self.sbt_params.to_dict()
        # set to None if client_type (nullable) is None
        # and model_fields_set contains the field
        if self.client_type is None and "client_type" in self.model_fields_set:
            _dict['clientType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExternallyTriggeredJobParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clientType": obj.get("clientType"),
            "sbtParams": ExternallyTriggeredSbtParams.from_dict(obj["sbtParams"]) if obj.get("sbtParams") is not None else None,
            "tags": obj.get("tags")
        })
        return _obj


