# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.filtered_object import FilteredObject
from typing import Set
from typing_extensions import Self

class FilteredObjectsResponseBody(BaseModel):
    """
    Specifies the filter details.
    """ # noqa: E501
    filtered_objects: Optional[List[FilteredObject]] = Field(default=None, description="Specifies the list of filtered Objects.", alias="filteredObjects")
    __properties: ClassVar[List[str]] = ["filteredObjects"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FilteredObjectsResponseBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in filtered_objects (list)
        _items = []
        if self.filtered_objects:
            for _item_filtered_objects in self.filtered_objects:
                if _item_filtered_objects:
                    _items.append(_item_filtered_objects.to_dict())
            _dict['filteredObjects'] = _items
        # set to None if filtered_objects (nullable) is None
        # and model_fields_set contains the field
        if self.filtered_objects is None and "filtered_objects" in self.model_fields_set:
            _dict['filteredObjects'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FilteredObjectsResponseBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "filteredObjects": [FilteredObject.from_dict(_item) for _item in obj["filteredObjects"]] if obj.get("filteredObjects") is not None else None
        })
        return _obj


