# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.nas_throttling_config import NasThrottlingConfig
from cohesity_sdk.helios.models.smb_mount_credentials import SmbMountCredentials
from typing import Set
from typing_extensions import Self

class FlashbladeRegistrationParams(BaseModel):
    """
    Specifies parameters to register an Flashblade Source.
    """ # noqa: E501
    api_token: Optional[StrictStr] = Field(description="Specifies the API Token of the Flashblade Source", alias="apiToken")
    back_up_smb_volumes: Optional[StrictBool] = Field(default=None, description="Specifies whether or not to back up SMB Volumes.", alias="backUpSMBVolumes")
    endpoint: Optional[StrictStr] = Field(description="Specifies the Hostname or IP Address Endpoint for the Flashblade Source.")
    smb_credentials: Optional[SmbMountCredentials] = Field(default=None, alias="smbCredentials")
    throttling_config: Optional[NasThrottlingConfig] = Field(default=None, alias="throttlingConfig")
    __properties: ClassVar[List[str]] = ["apiToken", "backUpSMBVolumes", "endpoint", "smbCredentials", "throttlingConfig"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FlashbladeRegistrationParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of smb_credentials
        if self.smb_credentials:
            _dict['smbCredentials'] = self.smb_credentials.to_dict()
        # override the default output from pydantic by calling `to_dict()` of throttling_config
        if self.throttling_config:
            _dict['throttlingConfig'] = self.throttling_config.to_dict()
        # set to None if api_token (nullable) is None
        # and model_fields_set contains the field
        if self.api_token is None and "api_token" in self.model_fields_set:
            _dict['apiToken'] = None

        # set to None if back_up_smb_volumes (nullable) is None
        # and model_fields_set contains the field
        if self.back_up_smb_volumes is None and "back_up_smb_volumes" in self.model_fields_set:
            _dict['backUpSMBVolumes'] = None

        # set to None if endpoint (nullable) is None
        # and model_fields_set contains the field
        if self.endpoint is None and "endpoint" in self.model_fields_set:
            _dict['endpoint'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FlashbladeRegistrationParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "apiToken": obj.get("apiToken"),
            "backUpSMBVolumes": obj.get("backUpSMBVolumes"),
            "endpoint": obj.get("endpoint"),
            "smbCredentials": SmbMountCredentials.from_dict(obj["smbCredentials"]) if obj.get("smbCredentials") is not None else None,
            "throttlingConfig": NasThrottlingConfig.from_dict(obj["throttlingConfig"]) if obj.get("throttlingConfig") is not None else None
        })
        return _obj


