# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.fleet_network_params import FleetNetworkParams
from cohesity_sdk.helios.models.fleet_tags import FleetTags
from typing import Set
from typing_extensions import Self

class FleetConfig(BaseModel):
    """
    Specifies various resources while deploying fleet params.
    """ # noqa: E501
    fleet_network_params: Optional[FleetNetworkParams] = Field(default=None, description="Specifies the network security groups within above VPC.", alias="fleetNetworkParams")
    fleet_subnet_type: Optional[StrictStr] = Field(default=None, description="Specifies the subnet type of the fleet.", alias="fleetSubnetType")
    fleet_tags: Optional[List[FleetTags]] = Field(default=None, description="Specifies the network security groups within above VPC.", alias="fleetTags")
    __properties: ClassVar[List[str]] = ["fleetNetworkParams", "fleetSubnetType", "fleetTags"]

    @field_validator('fleet_subnet_type')
    def fleet_subnet_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kCluster', 'kSourceVM', 'kCustom']):
            raise ValueError("must be one of enum values ('kCluster', 'kSourceVM', 'kCustom')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FleetConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of fleet_network_params
        if self.fleet_network_params:
            _dict['fleetNetworkParams'] = self.fleet_network_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in fleet_tags (list)
        _items = []
        if self.fleet_tags:
            for _item_fleet_tags in self.fleet_tags:
                if _item_fleet_tags:
                    _items.append(_item_fleet_tags.to_dict())
            _dict['fleetTags'] = _items
        # set to None if fleet_network_params (nullable) is None
        # and model_fields_set contains the field
        if self.fleet_network_params is None and "fleet_network_params" in self.model_fields_set:
            _dict['fleetNetworkParams'] = None

        # set to None if fleet_subnet_type (nullable) is None
        # and model_fields_set contains the field
        if self.fleet_subnet_type is None and "fleet_subnet_type" in self.model_fields_set:
            _dict['fleetSubnetType'] = None

        # set to None if fleet_tags (nullable) is None
        # and model_fields_set contains the field
        if self.fleet_tags is None and "fleet_tags" in self.model_fields_set:
            _dict['fleetTags'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FleetConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fleetNetworkParams": FleetNetworkParams.from_dict(obj["fleetNetworkParams"]) if obj.get("fleetNetworkParams") is not None else None,
            "fleetSubnetType": obj.get("fleetSubnetType"),
            "fleetTags": [FleetTags.from_dict(_item) for _item in obj["fleetTags"]] if obj.get("fleetTags") is not None else None
        })
        return _obj


