# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.aws_kms_key_resp import AwsKmsKeyResp
from cohesity_sdk.helios.models.fortknox_cloud_provider import FortknoxCloudProvider
from typing import Set
from typing_extensions import Self

class FortknoxKmsKeyInfo(BaseModel):
    """
    Information about KMS key for Fortknox.
    """ # noqa: E501
    account_id: StrictStr = Field(description="ID of the helios account.", alias="accountId")
    cloud_provider: Optional[FortknoxCloudProvider] = Field(default=None, alias="cloudProvider")
    kms_key_type: StrictStr = Field(description="Whether the KMS key is customer provided or by Cohesity.", alias="kmsKeyType")
    aws_params: Optional[AwsKmsKeyResp] = Field(default=None, alias="awsParams")
    global_kms_id: Optional[StrictStr] = Field(default=None, description="ID that uniquely identifies a KMS key.", alias="globalKmsId")
    __properties: ClassVar[List[str]] = ["accountId", "cloudProvider", "kmsKeyType", "awsParams", "globalKmsId"]

    @field_validator('kms_key_type')
    def kms_key_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['CohesityManaged', 'CustomerManaged']):
            raise ValueError("must be one of enum values ('CohesityManaged', 'CustomerManaged')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FortknoxKmsKeyInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aws_params
        if self.aws_params:
            _dict['awsParams'] = self.aws_params.to_dict()
        # set to None if global_kms_id (nullable) is None
        # and model_fields_set contains the field
        if self.global_kms_id is None and "global_kms_id" in self.model_fields_set:
            _dict['globalKmsId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FortknoxKmsKeyInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "cloudProvider": obj.get("cloudProvider"),
            "kmsKeyType": obj.get("kmsKeyType"),
            "awsParams": AwsKmsKeyResp.from_dict(obj["awsParams"]) if obj.get("awsParams") is not None else None,
            "globalKmsId": obj.get("globalKmsId")
        })
        return _obj


