# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.draa_sfetb_usage import DraaSFETBUsage
from typing import Set
from typing_extensions import Self

class FrontendUsage(BaseModel):
    """
    Specifies the TiB usage statistics.
    """ # noqa: E501
    current_usage: Optional[StrictInt] = Field(default=None, description="The current usage from the start of the month. This includes only DMaaS statistics.", alias="currentUsage")
    draas_usage: Optional[DraaSFETBUsage] = Field(default=None, alias="draasUsage")
    region_id: Optional[StrictStr] = Field(default=None, description="The current region for which usage is calculated.", alias="regionId")
    __properties: ClassVar[List[str]] = ["currentUsage", "draasUsage", "regionId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FrontendUsage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of draas_usage
        if self.draas_usage:
            _dict['draasUsage'] = self.draas_usage.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FrontendUsage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "currentUsage": obj.get("currentUsage"),
            "draasUsage": DraaSFETBUsage.from_dict(obj["draasUsage"]) if obj.get("draasUsage") is not None else None,
            "regionId": obj.get("regionId")
        })
        return _obj


