# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.archival_target_stats_info import ArchivalTargetStatsInfo
from cohesity_sdk.helios.models.backup_run_stats_info import BackupRunStatsInfo
from typing import Set
from typing_extensions import Self

class GetProtectionRunStatsBody(BaseModel):
    """
    Specifies the stats of a protection run.
    """ # noqa: E501
    archival_run: Optional[List[ArchivalTargetStatsInfo]] = Field(default=None, description="Stats for the archival run.", alias="archivalRun")
    local_run: Optional[BackupRunStatsInfo] = Field(default=None, alias="localRun")
    __properties: ClassVar[List[str]] = ["archivalRun", "localRun"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetProtectionRunStatsBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in archival_run (list)
        _items = []
        if self.archival_run:
            for _item_archival_run in self.archival_run:
                if _item_archival_run:
                    _items.append(_item_archival_run.to_dict())
            _dict['archivalRun'] = _items
        # override the default output from pydantic by calling `to_dict()` of local_run
        if self.local_run:
            _dict['localRun'] = self.local_run.to_dict()
        # set to None if archival_run (nullable) is None
        # and model_fields_set contains the field
        if self.archival_run is None and "archival_run" in self.model_fields_set:
            _dict['archivalRun'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetProtectionRunStatsBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "archivalRun": [ArchivalTargetStatsInfo.from_dict(_item) for _item in obj["archivalRun"]] if obj.get("archivalRun") is not None else None,
            "localRun": BackupRunStatsInfo.from_dict(obj["localRun"]) if obj.get("localRun") is not None else None
        })
        return _obj


