# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class GroupObjectEntityParams(BaseModel):
    """
    Specifies the common parameters for Office365 Group objects.
    """ # noqa: E501
    is_mail_enabled: Optional[StrictBool] = Field(default=None, description="Specifies whether the Group is mail enabled. Mail enabled groups are used within Microsoft to distribute messages.", alias="isMailEnabled")
    is_security_enabled: Optional[StrictBool] = Field(default=None, description="Specifies whether the Group is security enabled. Security enabled groups are used to grant access permissions to resources in Exchange and Active Directory.", alias="isSecurityEnabled")
    member_count: Optional[StrictInt] = Field(default=None, description="Specifies the count of members within the Group.", alias="memberCount")
    __properties: ClassVar[List[str]] = ["isMailEnabled", "isSecurityEnabled", "memberCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GroupObjectEntityParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if is_mail_enabled (nullable) is None
        # and model_fields_set contains the field
        if self.is_mail_enabled is None and "is_mail_enabled" in self.model_fields_set:
            _dict['isMailEnabled'] = None

        # set to None if is_security_enabled (nullable) is None
        # and model_fields_set contains the field
        if self.is_security_enabled is None and "is_security_enabled" in self.model_fields_set:
            _dict['isSecurityEnabled'] = None

        # set to None if member_count (nullable) is None
        # and model_fields_set contains the field
        if self.member_count is None and "member_count" in self.model_fields_set:
            _dict['memberCount'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GroupObjectEntityParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "isMailEnabled": obj.get("isMailEnabled"),
            "isSecurityEnabled": obj.get("isSecurityEnabled"),
            "memberCount": obj.get("memberCount")
        })
        return _obj


