# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.helios_bmr_backup_policy import HeliosBmrBackupPolicy
from cohesity_sdk.helios.models.helios_cdp_backup_policy import HeliosCdpBackupPolicy
from cohesity_sdk.helios.models.helios_log_backup_policy import HeliosLogBackupPolicy
from cohesity_sdk.helios.models.helios_regular_backup_policy import HeliosRegularBackupPolicy
from typing import Set
from typing_extensions import Self

class HeliosBackupPolicy(BaseModel):
    """
    Specifies the backup schedule and retentions of a Protection Policy.
    """ # noqa: E501
    bmr: Optional[HeliosBmrBackupPolicy] = None
    cdp: Optional[HeliosCdpBackupPolicy] = None
    log: Optional[HeliosLogBackupPolicy] = None
    regular: Optional[HeliosRegularBackupPolicy] = None
    __properties: ClassVar[List[str]] = ["bmr", "cdp", "log", "regular"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of HeliosBackupPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of bmr
        if self.bmr:
            _dict['bmr'] = self.bmr.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cdp
        if self.cdp:
            _dict['cdp'] = self.cdp.to_dict()
        # override the default output from pydantic by calling `to_dict()` of log
        if self.log:
            _dict['log'] = self.log.to_dict()
        # override the default output from pydantic by calling `to_dict()` of regular
        if self.regular:
            _dict['regular'] = self.regular.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of HeliosBackupPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bmr": HeliosBmrBackupPolicy.from_dict(obj["bmr"]) if obj.get("bmr") is not None else None,
            "cdp": HeliosCdpBackupPolicy.from_dict(obj["cdp"]) if obj.get("cdp") is not None else None,
            "log": HeliosLogBackupPolicy.from_dict(obj["log"]) if obj.get("log") is not None else None,
            "regular": HeliosRegularBackupPolicy.from_dict(obj["regular"]) if obj.get("regular") is not None else None
        })
        return _obj


