# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.helios_on_prem_mfa import HeliosOnPremMfa
from cohesity_sdk.helios.models.helios_saas_mfa import HeliosSaasMfa
from typing import Set
from typing_extensions import Self

class HeliosMfa(BaseModel):
    """
    Specifies MFA configuration for an account
    """ # noqa: E501
    deployment_type: Optional[StrictStr] = Field(description="Specifies the deployment type of the helios instance.", alias="deploymentType")
    helios_on_prem_config: Optional[HeliosOnPremMfa] = Field(default=None, alias="heliosOnPremConfig")
    helios_saas_config: Optional[HeliosSaasMfa] = Field(default=None, alias="heliosSaasConfig")
    __properties: ClassVar[List[str]] = ["deploymentType", "heliosOnPremConfig", "heliosSaasConfig"]

    @field_validator('deployment_type')
    def deployment_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['HeliosSaas', 'HeliosOnPrem']):
            raise ValueError("must be one of enum values ('HeliosSaas', 'HeliosOnPrem')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of HeliosMfa from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of helios_on_prem_config
        if self.helios_on_prem_config:
            _dict['heliosOnPremConfig'] = self.helios_on_prem_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of helios_saas_config
        if self.helios_saas_config:
            _dict['heliosSaasConfig'] = self.helios_saas_config.to_dict()
        # set to None if deployment_type (nullable) is None
        # and model_fields_set contains the field
        if self.deployment_type is None and "deployment_type" in self.model_fields_set:
            _dict['deploymentType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of HeliosMfa from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "deploymentType": obj.get("deploymentType"),
            "heliosOnPremConfig": HeliosOnPremMfa.from_dict(obj["heliosOnPremConfig"]) if obj.get("heliosOnPremConfig") is not None else None,
            "heliosSaasConfig": HeliosSaasMfa.from_dict(obj["heliosSaasConfig"]) if obj.get("heliosSaasConfig") is not None else None
        })
        return _obj


