# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class ImportCertificateByClientcsrResponseBody(BaseModel):
    """
    Specifies the response to import a certificate.
    """ # noqa: E501
    certificate_server: Optional[StrictStr] = Field(default=None, description="Specifies the server certificate.", alias="certificateServer")
    file_server_cert: Optional[StrictStr] = Field(default=None, description="Specifies the path to the file to be uploaded to server. This file has the server cert, id and encrypted private key", alias="fileServerCert")
    private_key: Optional[StrictStr] = Field(default=None, description="Specifies the private key of agent.", alias="privateKey")
    __properties: ClassVar[List[str]] = ["certificateServer", "fileServerCert", "privateKey"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImportCertificateByClientcsrResponseBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if certificate_server (nullable) is None
        # and model_fields_set contains the field
        if self.certificate_server is None and "certificate_server" in self.model_fields_set:
            _dict['certificateServer'] = None

        # set to None if file_server_cert (nullable) is None
        # and model_fields_set contains the field
        if self.file_server_cert is None and "file_server_cert" in self.model_fields_set:
            _dict['fileServerCert'] = None

        # set to None if private_key (nullable) is None
        # and model_fields_set contains the field
        if self.private_key is None and "private_key" in self.model_fields_set:
            _dict['privateKey'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImportCertificateByClientcsrResponseBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "certificateServer": obj.get("certificateServer"),
            "fileServerCert": obj.get("fileServerCert"),
            "privateKey": obj.get("privateKey")
        })
        return _obj


