# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class IndexingPolicy(BaseModel):
    """
    Specifies settings for indexing files found in an Object (such as a VM) so these files can be searched and recovered. This also specifies inclusion and exclusion rules that determine the directories to index.
    """ # noqa: E501
    enable_indexing: Optional[StrictBool] = Field(description="Specifies if the files found in an Object (such as a VM) should be indexed. If true (the default), files are indexed.", alias="enableIndexing")
    exclude_paths: Optional[List[StrictStr]] = Field(default=None, description="Array of Excluded Directories. Specifies a list of directories to exclude from indexing.Regular expression can also be specified to provide the directory paths. Example: /Users/<wildcard>/AppData", alias="excludePaths")
    include_paths: Optional[List[StrictStr]] = Field(default=None, description="Array of Indexed Directories. Specifies a list of directories to index. Regular expression can also be specified to provide the directory paths. Example: /Users/<wildcard>/AppData", alias="includePaths")
    __properties: ClassVar[List[str]] = ["enableIndexing", "excludePaths", "includePaths"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IndexingPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if enable_indexing (nullable) is None
        # and model_fields_set contains the field
        if self.enable_indexing is None and "enable_indexing" in self.model_fields_set:
            _dict['enableIndexing'] = None

        # set to None if exclude_paths (nullable) is None
        # and model_fields_set contains the field
        if self.exclude_paths is None and "exclude_paths" in self.model_fields_set:
            _dict['excludePaths'] = None

        # set to None if include_paths (nullable) is None
        # and model_fields_set contains the field
        if self.include_paths is None and "include_paths" in self.model_fields_set:
            _dict['includePaths'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IndexingPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enableIndexing": obj.get("enableIndexing"),
            "excludePaths": obj.get("excludePaths"),
            "includePaths": obj.get("includePaths")
        })
        return _obj


