# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from cohesity_sdk.helios.models.keystone_admin_params import KeystoneAdminParams
from cohesity_sdk.helios.models.keystone_scope_params import KeystoneScopeParams
from typing import Optional, Set
from typing_extensions import Self

class KeystoneCredentials(BaseModel):
    """
    Specifies user credentials of a Keystone server.
    """ # noqa: E501
    admin_creds: KeystoneAdminParams = Field(description="Specifies parameters related to Keystone administrator.", alias="adminCreds")
    scope: KeystoneScopeParams = Field(description="Specifies parameters related to Keystone scope.")
    __properties: ClassVar[List[str]] = ["adminCreds", "scope"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of KeystoneCredentials from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of admin_creds
        if self.admin_creds:
            _dict['adminCreds'] = self.admin_creds.to_dict()
        # override the default output from pydantic by calling `to_dict()` of scope
        if self.scope:
            _dict['scope'] = self.scope.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of KeystoneCredentials from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "adminCreds": KeystoneAdminParams.from_dict(obj["adminCreds"]) if obj.get("adminCreds") is not None else None,
            "scope": KeystoneScopeParams.from_dict(obj["scope"]) if obj.get("scope") is not None else None
        })
        return _obj


