# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.domain_scope_params import DomainScopeParams
from cohesity_sdk.helios.models.project_scope_params import ProjectScopeParams
from typing import Set
from typing_extensions import Self

class KeystoneScopeParams(BaseModel):
    """
    Specifies scope paramteres of a Keystone.
    """ # noqa: E501
    domain_scope_params: Optional[DomainScopeParams] = Field(default=None, description="Specifies the parameters for domain type scope.", alias="domainScopeParams")
    project_scope_params: Optional[ProjectScopeParams] = Field(default=None, description="Specifies the parameter for project type scope.", alias="projectScopeParams")
    type: Optional[StrictStr] = Field(description="Specifies the scope type.")
    __properties: ClassVar[List[str]] = ["domainScopeParams", "projectScopeParams", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Project', 'Domain']):
            raise ValueError("must be one of enum values ('Project', 'Domain')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of KeystoneScopeParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of domain_scope_params
        if self.domain_scope_params:
            _dict['domainScopeParams'] = self.domain_scope_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of project_scope_params
        if self.project_scope_params:
            _dict['projectScopeParams'] = self.project_scope_params.to_dict()
        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of KeystoneScopeParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "domainScopeParams": DomainScopeParams.from_dict(obj["domainScopeParams"]) if obj.get("domainScopeParams") is not None else None,
            "projectScopeParams": ProjectScopeParams.from_dict(obj["projectScopeParams"]) if obj.get("projectScopeParams") is not None else None,
            "type": obj.get("type")
        })
        return _obj


