# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class LocalUserUpdateParams(BaseModel):
    """
    Specifies properties for LOCAL cohesity user which are updatable.
    """ # noqa: E501
    email: Optional[StrictStr] = Field(default=None, description="Specifies the email address of the User.")
    groups: Optional[List[StrictStr]] = Field(default=None, description="Specifies additional groups the User may belong to.")
    password: Optional[StrictStr] = Field(default=None, description="Specifies the password of the User.")
    primary_group: Optional[StrictStr] = Field(default=None, description="Specifies the primary group of the User. Primary group is used for file access.", alias="primaryGroup")
    current_password: Optional[StrictStr] = Field(default=None, description="Specifies the current password of the user. This is required when a session user tries to update his own password.", alias="currentPassword")
    __properties: ClassVar[List[str]] = ["email", "groups", "password", "primaryGroup", "currentPassword"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LocalUserUpdateParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "groups",
            "primary_group",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if email (nullable) is None
        # and model_fields_set contains the field
        if self.email is None and "email" in self.model_fields_set:
            _dict['email'] = None

        # set to None if password (nullable) is None
        # and model_fields_set contains the field
        if self.password is None and "password" in self.model_fields_set:
            _dict['password'] = None

        # set to None if primary_group (nullable) is None
        # and model_fields_set contains the field
        if self.primary_group is None and "primary_group" in self.model_fields_set:
            _dict['primaryGroup'] = None

        # set to None if current_password (nullable) is None
        # and model_fields_set contains the field
        if self.current_password is None and "current_password" in self.model_fields_set:
            _dict['currentPassword'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LocalUserUpdateParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "email": obj.get("email"),
            "groups": obj.get("groups"),
            "password": obj.get("password"),
            "primaryGroup": obj.get("primaryGroup"),
            "currentPassword": obj.get("currentPassword")
        })
        return _obj


