# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.mcm_object_activity import McmObjectActivity
from cohesity_sdk.helios.models.mcm_object_activity_stats import McmObjectActivityStats
from typing import Set
from typing_extensions import Self

class McmObjectLastRunActivities(BaseModel):
    """
    Last protection runs info of objects.
    """ # noqa: E501
    object_last_runs: Optional[List[McmObjectActivity]] = Field(default=None, description="Specifies a list of last protection run activities of objects.", alias="objectLastRuns")
    stats: Optional[List[McmObjectActivityStats]] = Field(default=None, description="Specifies the stats of object activity.")
    __properties: ClassVar[List[str]] = ["objectLastRuns", "stats"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of McmObjectLastRunActivities from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in object_last_runs (list)
        _items = []
        if self.object_last_runs:
            for _item_object_last_runs in self.object_last_runs:
                if _item_object_last_runs:
                    _items.append(_item_object_last_runs.to_dict())
            _dict['objectLastRuns'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in stats (list)
        _items = []
        if self.stats:
            for _item_stats in self.stats:
                if _item_stats:
                    _items.append(_item_stats.to_dict())
            _dict['stats'] = _items
        # set to None if object_last_runs (nullable) is None
        # and model_fields_set contains the field
        if self.object_last_runs is None and "object_last_runs" in self.model_fields_set:
            _dict['objectLastRuns'] = None

        # set to None if stats (nullable) is None
        # and model_fields_set contains the field
        if self.stats is None and "stats" in self.model_fields_set:
            _dict['stats'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of McmObjectLastRunActivities from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "objectLastRuns": [McmObjectActivity.from_dict(_item) for _item in obj["objectLastRuns"]] if obj.get("objectLastRuns") is not None else None,
            "stats": [McmObjectActivityStats.from_dict(_item) for _item in obj["stats"]] if obj.get("stats") is not None else None
        })
        return _obj


