# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.mcm_protection_group_archival_run_activity_params import McmProtectionGroupArchivalRunActivityParams
from cohesity_sdk.helios.models.mcm_protection_group_backup_run_activity_params import McmProtectionGroupBackupRunActivityParams
from typing import Set
from typing_extensions import Self

class McmProtectionGroupActivity(BaseModel):
    """
    Specifies the Protection Group activity.
    """ # noqa: E501
    archival_run_params: Optional[McmProtectionGroupArchivalRunActivityParams] = Field(default=None, alias="archivalRunParams")
    backup_run_params: Optional[McmProtectionGroupBackupRunActivityParams] = Field(default=None, alias="backupRunParams")
    cluster_id: Optional[StrictInt] = Field(default=None, description="Specifies the cluster id.", alias="clusterId")
    cluster_incarnation_id: Optional[StrictInt] = Field(default=None, description="Specifies the cluster incarnation id.", alias="clusterIncarnationId")
    cluster_name: Optional[StrictStr] = Field(default=None, description="Specifies the cluster name.", alias="clusterName")
    id: Optional[StrictStr] = Field(default=None, description="Specifies the unique id of the activity event.")
    policy_id: Optional[StrictStr] = Field(default=None, description="Specifies the Protection Policy Id.", alias="policyId")
    policy_name: Optional[StrictStr] = Field(default=None, description="Specifies the Protection Policy Name.", alias="policyName")
    protection_group_id: Optional[StrictStr] = Field(default=None, description="Specifies the Protection Group Id.", alias="protectionGroupId")
    protection_group_name: Optional[StrictStr] = Field(default=None, description="Specifies the Protection Group name.", alias="protectionGroupName")
    region_id: Optional[StrictStr] = Field(default=None, description="Specifies the region id.", alias="regionId")
    run_id: Optional[StrictStr] = Field(default=None, description="Specifies the ID of the Protection Run.", alias="runId")
    timestamp_usecs: Optional[StrictInt] = Field(default=None, description="Specifies the timestamp in Unix timestamp epoch in microseconds at which this activity occured.", alias="timestampUsecs")
    type: Optional[StrictStr] = Field(default=None, description="Specifies the type of activity event.")
    __properties: ClassVar[List[str]] = ["archivalRunParams", "backupRunParams", "clusterId", "clusterIncarnationId", "clusterName", "id", "policyId", "policyName", "protectionGroupId", "protectionGroupName", "regionId", "runId", "timestampUsecs", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['BackupRun', 'ArchivalRun']):
            raise ValueError("must be one of enum values ('BackupRun', 'ArchivalRun')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of McmProtectionGroupActivity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "region_id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of archival_run_params
        if self.archival_run_params:
            _dict['archivalRunParams'] = self.archival_run_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of backup_run_params
        if self.backup_run_params:
            _dict['backupRunParams'] = self.backup_run_params.to_dict()
        # set to None if cluster_id (nullable) is None
        # and model_fields_set contains the field
        if self.cluster_id is None and "cluster_id" in self.model_fields_set:
            _dict['clusterId'] = None

        # set to None if cluster_incarnation_id (nullable) is None
        # and model_fields_set contains the field
        if self.cluster_incarnation_id is None and "cluster_incarnation_id" in self.model_fields_set:
            _dict['clusterIncarnationId'] = None

        # set to None if cluster_name (nullable) is None
        # and model_fields_set contains the field
        if self.cluster_name is None and "cluster_name" in self.model_fields_set:
            _dict['clusterName'] = None

        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if policy_id (nullable) is None
        # and model_fields_set contains the field
        if self.policy_id is None and "policy_id" in self.model_fields_set:
            _dict['policyId'] = None

        # set to None if policy_name (nullable) is None
        # and model_fields_set contains the field
        if self.policy_name is None and "policy_name" in self.model_fields_set:
            _dict['policyName'] = None

        # set to None if protection_group_id (nullable) is None
        # and model_fields_set contains the field
        if self.protection_group_id is None and "protection_group_id" in self.model_fields_set:
            _dict['protectionGroupId'] = None

        # set to None if protection_group_name (nullable) is None
        # and model_fields_set contains the field
        if self.protection_group_name is None and "protection_group_name" in self.model_fields_set:
            _dict['protectionGroupName'] = None

        # set to None if region_id (nullable) is None
        # and model_fields_set contains the field
        if self.region_id is None and "region_id" in self.model_fields_set:
            _dict['regionId'] = None

        # set to None if run_id (nullable) is None
        # and model_fields_set contains the field
        if self.run_id is None and "run_id" in self.model_fields_set:
            _dict['runId'] = None

        # set to None if timestamp_usecs (nullable) is None
        # and model_fields_set contains the field
        if self.timestamp_usecs is None and "timestamp_usecs" in self.model_fields_set:
            _dict['timestampUsecs'] = None

        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of McmProtectionGroupActivity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "archivalRunParams": McmProtectionGroupArchivalRunActivityParams.from_dict(obj["archivalRunParams"]) if obj.get("archivalRunParams") is not None else None,
            "backupRunParams": McmProtectionGroupBackupRunActivityParams.from_dict(obj["backupRunParams"]) if obj.get("backupRunParams") is not None else None,
            "clusterId": obj.get("clusterId"),
            "clusterIncarnationId": obj.get("clusterIncarnationId"),
            "clusterName": obj.get("clusterName"),
            "id": obj.get("id"),
            "policyId": obj.get("policyId"),
            "policyName": obj.get("policyName"),
            "protectionGroupId": obj.get("protectionGroupId"),
            "protectionGroupName": obj.get("protectionGroupName"),
            "regionId": obj.get("regionId"),
            "runId": obj.get("runId"),
            "timestampUsecs": obj.get("timestampUsecs"),
            "type": obj.get("type")
        })
        return _obj


