# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.mcm_cluster_identifier import McmClusterIdentifier
from typing import Set
from typing_extensions import Self

class McmTenantProfile(BaseModel):
    """
    Specifies tenant profile.
    """ # noqa: E501
    clusters: Optional[List[McmClusterIdentifier]] = Field(default=None, description="Specifies the list of clusters owned by this account id.")
    tenant_id: Optional[StrictStr] = Field(description="Specifies the tenant id.", alias="tenantId")
    tenant_name: Optional[StrictStr] = Field(default=None, description="Specifies the tenant id.", alias="tenantName")
    tenant_type: Optional[StrictStr] = Field(description="Specifies the type of tenant.", alias="tenantType")
    __properties: ClassVar[List[str]] = ["clusters", "tenantId", "tenantName", "tenantType"]

    @field_validator('tenant_type')
    def tenant_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Dmaas', 'Mcm']):
            raise ValueError("must be one of enum values ('Dmaas', 'Mcm')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of McmTenantProfile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "tenant_name",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in clusters (list)
        _items = []
        if self.clusters:
            for _item_clusters in self.clusters:
                if _item_clusters:
                    _items.append(_item_clusters.to_dict())
            _dict['clusters'] = _items
        # set to None if tenant_id (nullable) is None
        # and model_fields_set contains the field
        if self.tenant_id is None and "tenant_id" in self.model_fields_set:
            _dict['tenantId'] = None

        # set to None if tenant_name (nullable) is None
        # and model_fields_set contains the field
        if self.tenant_name is None and "tenant_name" in self.model_fields_set:
            _dict['tenantName'] = None

        # set to None if tenant_type (nullable) is None
        # and model_fields_set contains the field
        if self.tenant_type is None and "tenant_type" in self.model_fields_set:
            _dict['tenantType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of McmTenantProfile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clusters": [McmClusterIdentifier.from_dict(_item) for _item in obj["clusters"]] if obj.get("clusters") is not None else None,
            "tenantId": obj.get("tenantId"),
            "tenantName": obj.get("tenantName"),
            "tenantType": obj.get("tenantType")
        })
        return _obj


