# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.common_mssql_file_object_protection_params import CommonMssqlFileObjectProtectionParams
from cohesity_sdk.helios.models.common_mssql_native_object_protection_params import CommonMssqlNativeObjectProtectionParams
from typing import Set
from typing_extensions import Self

class MssqlObjectProtectionResponseParams(BaseModel):
    """
    Specifies the response parameters specific to MSSQL object protection.
    """ # noqa: E501
    common_file_object_protection_type_params: Optional[CommonMssqlFileObjectProtectionParams] = Field(default=None, alias="commonFileObjectProtectionTypeParams")
    common_native_object_protection_type_params: Optional[CommonMssqlNativeObjectProtectionParams] = Field(default=None, alias="commonNativeObjectProtectionTypeParams")
    object_protection_type: StrictStr = Field(description="Specifies the MSSQL Object Protection type.", alias="objectProtectionType")
    __properties: ClassVar[List[str]] = ["commonFileObjectProtectionTypeParams", "commonNativeObjectProtectionTypeParams", "objectProtectionType"]

    @field_validator('object_protection_type')
    def object_protection_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['kFile', 'kVolume', 'kNative']):
            raise ValueError("must be one of enum values ('kFile', 'kVolume', 'kNative')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MssqlObjectProtectionResponseParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of common_file_object_protection_type_params
        if self.common_file_object_protection_type_params:
            _dict['commonFileObjectProtectionTypeParams'] = self.common_file_object_protection_type_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of common_native_object_protection_type_params
        if self.common_native_object_protection_type_params:
            _dict['commonNativeObjectProtectionTypeParams'] = self.common_native_object_protection_type_params.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MssqlObjectProtectionResponseParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "commonFileObjectProtectionTypeParams": CommonMssqlFileObjectProtectionParams.from_dict(obj["commonFileObjectProtectionTypeParams"]) if obj.get("commonFileObjectProtectionTypeParams") is not None else None,
            "commonNativeObjectProtectionTypeParams": CommonMssqlNativeObjectProtectionParams.from_dict(obj["commonNativeObjectProtectionTypeParams"]) if obj.get("commonNativeObjectProtectionTypeParams") is not None else None,
            "objectProtectionType": obj.get("objectProtectionType")
        })
        return _obj


