# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.email_config import EmailConfig
from cohesity_sdk.helios.models.webhook_config import WebhookConfig
from typing import Set
from typing_extensions import Self

class NotificationInfo(BaseModel):
    """
    Specifies the details of an anomaly notification
    """ # noqa: E501
    anomaly_strength_threshold: Optional[StrictInt] = Field(default=None, description="Anomaly strength level beyond which notification has to be sent.", alias="anomalyStrengthThreshold")
    email_config: Optional[EmailConfig] = Field(default=None, alias="emailConfig")
    webhook_config: Optional[WebhookConfig] = Field(default=None, alias="webhookConfig")
    __properties: ClassVar[List[str]] = ["anomalyStrengthThreshold", "emailConfig", "webhookConfig"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NotificationInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of email_config
        if self.email_config:
            _dict['emailConfig'] = self.email_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of webhook_config
        if self.webhook_config:
            _dict['webhookConfig'] = self.webhook_config.to_dict()
        # set to None if anomaly_strength_threshold (nullable) is None
        # and model_fields_set contains the field
        if self.anomaly_strength_threshold is None and "anomaly_strength_threshold" in self.model_fields_set:
            _dict['anomalyStrengthThreshold'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NotificationInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "anomalyStrengthThreshold": obj.get("anomalyStrengthThreshold"),
            "emailConfig": EmailConfig.from_dict(obj["emailConfig"]) if obj.get("emailConfig") is not None else None,
            "webhookConfig": WebhookConfig.from_dict(obj["webhookConfig"]) if obj.get("webhookConfig") is not None else None
        })
        return _obj


