# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.oracle_range_meta_info import OracleRangeMetaInfo
from typing import Set
from typing_extensions import Self

class OracleRestoreRangeInfo(BaseModel):
    """
    Specifies Restore Ranges related to an Oracle Database
    """ # noqa: E501
    scn_range_info: Optional[List[OracleRangeMetaInfo]] = Field(default=None, description="Specifies an array of SCN based oracle restore ranges.", alias="ScnRangeInfo")
    sequence_range_info: Optional[List[OracleRangeMetaInfo]] = Field(default=None, description="Specifies an array of time based oracle restore ranges.", alias="SequenceRangeInfo")
    time_range_info: Optional[List[OracleRangeMetaInfo]] = Field(default=None, description="Specifies an array of time based oracle restore ranges.", alias="TimeRangeInfo")
    __properties: ClassVar[List[str]] = ["ScnRangeInfo", "SequenceRangeInfo", "TimeRangeInfo"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OracleRestoreRangeInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in scn_range_info (list)
        _items = []
        if self.scn_range_info:
            for _item_scn_range_info in self.scn_range_info:
                if _item_scn_range_info:
                    _items.append(_item_scn_range_info.to_dict())
            _dict['ScnRangeInfo'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in sequence_range_info (list)
        _items = []
        if self.sequence_range_info:
            for _item_sequence_range_info in self.sequence_range_info:
                if _item_sequence_range_info:
                    _items.append(_item_sequence_range_info.to_dict())
            _dict['SequenceRangeInfo'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in time_range_info (list)
        _items = []
        if self.time_range_info:
            for _item_time_range_info in self.time_range_info:
                if _item_time_range_info:
                    _items.append(_item_time_range_info.to_dict())
            _dict['TimeRangeInfo'] = _items
        # set to None if scn_range_info (nullable) is None
        # and model_fields_set contains the field
        if self.scn_range_info is None and "scn_range_info" in self.model_fields_set:
            _dict['ScnRangeInfo'] = None

        # set to None if sequence_range_info (nullable) is None
        # and model_fields_set contains the field
        if self.sequence_range_info is None and "sequence_range_info" in self.model_fields_set:
            _dict['SequenceRangeInfo'] = None

        # set to None if time_range_info (nullable) is None
        # and model_fields_set contains the field
        if self.time_range_info is None and "time_range_info" in self.model_fields_set:
            _dict['TimeRangeInfo'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OracleRestoreRangeInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ScnRangeInfo": [OracleRangeMetaInfo.from_dict(_item) for _item in obj["ScnRangeInfo"]] if obj.get("ScnRangeInfo") is not None else None,
            "SequenceRangeInfo": [OracleRangeMetaInfo.from_dict(_item) for _item in obj["SequenceRangeInfo"]] if obj.get("SequenceRangeInfo") is not None else None,
            "TimeRangeInfo": [OracleRangeMetaInfo.from_dict(_item) for _item in obj["TimeRangeInfo"]] if obj.get("TimeRangeInfo") is not None else None
        })
        return _obj


