# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class OracleVlanInfo(BaseModel):
    """
    Specifies details about capturing Cohesity cluster VLAN info for Oracle workflow.
    """ # noqa: E501
    gateway: Optional[StrictStr] = Field(default=None, description="Specifies the gateway of this VLAN.")
    id: Optional[StrictInt] = Field(default=None, description="Specifies the Id of this VLAN.")
    ip_list: Optional[List[StrictStr]] = Field(default=None, description="Specifies the list of Ips in this VLAN.", alias="ipList")
    subnet_ip: Optional[StrictStr] = Field(default=None, description="Specifies the subnet Ip for this VLAN.", alias="subnetIp")
    __properties: ClassVar[List[str]] = ["gateway", "id", "ipList", "subnetIp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OracleVlanInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if gateway (nullable) is None
        # and model_fields_set contains the field
        if self.gateway is None and "gateway" in self.model_fields_set:
            _dict['gateway'] = None

        # set to None if ip_list (nullable) is None
        # and model_fields_set contains the field
        if self.ip_list is None and "ip_list" in self.model_fields_set:
            _dict['ipList'] = None

        # set to None if subnet_ip (nullable) is None
        # and model_fields_set contains the field
        if self.subnet_ip is None and "subnet_ip" in self.model_fields_set:
            _dict['subnetIp'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OracleVlanInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "gateway": obj.get("gateway"),
            "id": obj.get("id"),
            "ipList": obj.get("ipList"),
            "subnetIp": obj.get("subnetIp")
        })
        return _obj


