# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.physical_file_protection_group_params import PhysicalFileProtectionGroupParams
from cohesity_sdk.helios.models.physical_volume_protection_group_params import PhysicalVolumeProtectionGroupParams
from typing import Set
from typing_extensions import Self

class PhysicalObjectProtectionResponseParams(BaseModel):
    """
    Specifies the response parameters specific to Physical object protection.
    """ # noqa: E501
    file_object_protection_type_params: Optional[PhysicalFileProtectionGroupParams] = Field(default=None, alias="fileObjectProtectionTypeParams")
    object_protection_type: Optional[StrictStr] = Field(description="Specifies the Physical Object Protection type.", alias="objectProtectionType")
    volume_object_protection_type_params: Optional[PhysicalVolumeProtectionGroupParams] = Field(default=None, alias="volumeObjectProtectionTypeParams")
    __properties: ClassVar[List[str]] = ["fileObjectProtectionTypeParams", "objectProtectionType", "volumeObjectProtectionTypeParams"]

    @field_validator('object_protection_type')
    def object_protection_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kFile', 'kVolume']):
            raise ValueError("must be one of enum values ('kFile', 'kVolume')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PhysicalObjectProtectionResponseParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of file_object_protection_type_params
        if self.file_object_protection_type_params:
            _dict['fileObjectProtectionTypeParams'] = self.file_object_protection_type_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of volume_object_protection_type_params
        if self.volume_object_protection_type_params:
            _dict['volumeObjectProtectionTypeParams'] = self.volume_object_protection_type_params.to_dict()
        # set to None if file_object_protection_type_params (nullable) is None
        # and model_fields_set contains the field
        if self.file_object_protection_type_params is None and "file_object_protection_type_params" in self.model_fields_set:
            _dict['fileObjectProtectionTypeParams'] = None

        # set to None if object_protection_type (nullable) is None
        # and model_fields_set contains the field
        if self.object_protection_type is None and "object_protection_type" in self.model_fields_set:
            _dict['objectProtectionType'] = None

        # set to None if volume_object_protection_type_params (nullable) is None
        # and model_fields_set contains the field
        if self.volume_object_protection_type_params is None and "volume_object_protection_type_params" in self.model_fields_set:
            _dict['volumeObjectProtectionTypeParams'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PhysicalObjectProtectionResponseParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fileObjectProtectionTypeParams": PhysicalFileProtectionGroupParams.from_dict(obj["fileObjectProtectionTypeParams"]) if obj.get("fileObjectProtectionTypeParams") is not None else None,
            "objectProtectionType": obj.get("objectProtectionType"),
            "volumeObjectProtectionTypeParams": PhysicalVolumeProtectionGroupParams.from_dict(obj["volumeObjectProtectionTypeParams"]) if obj.get("volumeObjectProtectionTypeParams") is not None else None
        })
        return _obj


