# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.principal import Principal
from typing import Set
from typing_extensions import Self

class PrincipalList(BaseModel):
    """
    Specifies the list of the principals in helios.
    """ # noqa: E501
    pagination_token: Optional[StrictStr] = Field(default=None, description="Specifies page number of AD principals in the search results.", alias="paginationToken")
    principals: Optional[List[Principal]] = Field(default=None, description="Specifies AD principals in the search results.")
    total: Optional[StrictInt] = Field(default=None, description="Specifies total number of principals in helios.")
    __properties: ClassVar[List[str]] = ["paginationToken", "principals", "total"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PrincipalList from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in principals (list)
        _items = []
        if self.principals:
            for _item_principals in self.principals:
                if _item_principals:
                    _items.append(_item_principals.to_dict())
            _dict['principals'] = _items
        # set to None if pagination_token (nullable) is None
        # and model_fields_set contains the field
        if self.pagination_token is None and "pagination_token" in self.model_fields_set:
            _dict['paginationToken'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PrincipalList from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "paginationToken": obj.get("paginationToken"),
            "principals": [Principal.from_dict(_item) for _item in obj["principals"]] if obj.get("principals") is not None else None,
            "total": obj.get("total")
        })
        return _obj


