# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from cohesity_sdk.helios.models.run_now_action_object_level_params import RunNowActionObjectLevelParams
from typing import Set
from typing_extensions import Self

class ProtectedObjectRunNowActionParams(BaseModel):
    """
    Specifies the request parameters for RunNow action on Protected objects.
    """ # noqa: E501
    objects: Optional[Annotated[List[RunNowActionObjectLevelParams], Field(min_length=1)]] = Field(default=None, description="Specifies the list of objects to perform an action. If provided object id is not explicitly protected by object protection, then given action will not be performed on that.")
    run_label: Optional[StrictStr] = Field(default=None, description="Specifies a label with which this run is created. Only applicable for user triggered protect now action.", alias="runLabel")
    __properties: ClassVar[List[str]] = ["objects", "runLabel"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProtectedObjectRunNowActionParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in objects (list)
        _items = []
        if self.objects:
            for _item_objects in self.objects:
                if _item_objects:
                    _items.append(_item_objects.to_dict())
            _dict['objects'] = _items
        # set to None if run_label (nullable) is None
        # and model_fields_set contains the field
        if self.run_label is None and "run_label" in self.model_fields_set:
            _dict['runLabel'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProtectedObjectRunNowActionParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "objects": [RunNowActionObjectLevelParams.from_dict(_item) for _item in obj["objects"]] if obj.get("objects") is not None else None,
            "runLabel": obj.get("runLabel")
        })
        return _obj


