# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.recover_hyper_vvm_scvmm_source_config import RecoverHyperVVmSCVMMSourceConfig
from cohesity_sdk.helios.models.recover_hyper_vvm_standalone_cluster_source_config import RecoverHyperVVmStandaloneClusterSourceConfig
from cohesity_sdk.helios.models.recover_hyper_vvm_standalone_host_source_config import RecoverHyperVVmStandaloneHostSourceConfig
from typing import Set
from typing_extensions import Self

class RecoverHyperVVmNewSourceConfig(BaseModel):
    """
    Specifies the new destination Source configuration where the VMs will be recovered.
    """ # noqa: E501
    scvmm_server_params: Optional[RecoverHyperVVmSCVMMSourceConfig] = Field(default=None, alias="scvmmServerParams")
    source_type: Optional[StrictStr] = Field(description="Specifies the type of HyperV source to which the VMs are being restored.", alias="sourceType")
    standalone_cluster_params: Optional[RecoverHyperVVmStandaloneClusterSourceConfig] = Field(default=None, alias="standaloneClusterParams")
    standalone_host_params: Optional[RecoverHyperVVmStandaloneHostSourceConfig] = Field(default=None, alias="standaloneHostParams")
    __properties: ClassVar[List[str]] = ["scvmmServerParams", "sourceType", "standaloneClusterParams", "standaloneHostParams"]

    @field_validator('source_type')
    def source_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kSCVMMServer', 'kStandaloneHost', 'kStandaloneCluster']):
            raise ValueError("must be one of enum values ('kSCVMMServer', 'kStandaloneHost', 'kStandaloneCluster')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RecoverHyperVVmNewSourceConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of scvmm_server_params
        if self.scvmm_server_params:
            _dict['scvmmServerParams'] = self.scvmm_server_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of standalone_cluster_params
        if self.standalone_cluster_params:
            _dict['standaloneClusterParams'] = self.standalone_cluster_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of standalone_host_params
        if self.standalone_host_params:
            _dict['standaloneHostParams'] = self.standalone_host_params.to_dict()
        # set to None if source_type (nullable) is None
        # and model_fields_set contains the field
        if self.source_type is None and "source_type" in self.model_fields_set:
            _dict['sourceType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RecoverHyperVVmNewSourceConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "scvmmServerParams": RecoverHyperVVmSCVMMSourceConfig.from_dict(obj["scvmmServerParams"]) if obj.get("scvmmServerParams") is not None else None,
            "sourceType": obj.get("sourceType"),
            "standaloneClusterParams": RecoverHyperVVmStandaloneClusterSourceConfig.from_dict(obj["standaloneClusterParams"]) if obj.get("standaloneClusterParams") is not None else None,
            "standaloneHostParams": RecoverHyperVVmStandaloneHostSourceConfig.from_dict(obj["standaloneHostParams"]) if obj.get("standaloneHostParams") is not None else None
        })
        return _obj


