# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.recover_vmware_vm_esxi_source_config import RecoverVmwareVmEsxiSourceConfig
from cohesity_sdk.helios.models.recover_vmware_vm_v_center_source_config import RecoverVmwareVmVCenterSourceConfig
from cohesity_sdk.helios.models.recover_vmware_vm_vcd_source_config import RecoverVmwareVmVCDSourceConfig
from typing import Set
from typing_extensions import Self

class RecoverVmwareVmNewSourceConfig(BaseModel):
    """
    Specifies the new destination Source configuration where the VMs will be recovered.
    """ # noqa: E501
    source_type: Optional[StrictStr] = Field(description="Specifies the type of VMware source to which the VMs are being restored.", alias="sourceType")
    standalone_host_params: Optional[RecoverVmwareVmEsxiSourceConfig] = Field(default=None, alias="standaloneHostParams")
    v_center_params: Optional[RecoverVmwareVmVCenterSourceConfig] = Field(default=None, alias="vCenterParams")
    v_cloud_director_params: Optional[RecoverVmwareVmVCDSourceConfig] = Field(default=None, alias="vCloudDirectorParams")
    __properties: ClassVar[List[str]] = ["sourceType", "standaloneHostParams", "vCenterParams", "vCloudDirectorParams"]

    @field_validator('source_type')
    def source_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['kVCenter', 'kStandaloneHost', 'kvCloudDirector']):
            raise ValueError("must be one of enum values ('kVCenter', 'kStandaloneHost', 'kvCloudDirector')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RecoverVmwareVmNewSourceConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of standalone_host_params
        if self.standalone_host_params:
            _dict['standaloneHostParams'] = self.standalone_host_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of v_center_params
        if self.v_center_params:
            _dict['vCenterParams'] = self.v_center_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of v_cloud_director_params
        if self.v_cloud_director_params:
            _dict['vCloudDirectorParams'] = self.v_cloud_director_params.to_dict()
        # set to None if source_type (nullable) is None
        # and model_fields_set contains the field
        if self.source_type is None and "source_type" in self.model_fields_set:
            _dict['sourceType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RecoverVmwareVmNewSourceConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceType": obj.get("sourceType"),
            "standaloneHostParams": RecoverVmwareVmEsxiSourceConfig.from_dict(obj["standaloneHostParams"]) if obj.get("standaloneHostParams") is not None else None,
            "vCenterParams": RecoverVmwareVmVCenterSourceConfig.from_dict(obj["vCenterParams"]) if obj.get("vCenterParams") is not None else None,
            "vCloudDirectorParams": RecoverVmwareVmVCDSourceConfig.from_dict(obj["vCloudDirectorParams"]) if obj.get("vCloudDirectorParams") is not None else None
        })
        return _obj


