# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class ReplicationDataStats(BaseModel):
    """
    Specifies statistics about replication data.
    """ # noqa: E501
    logical_bytes_transferred: Optional[StrictInt] = Field(default=None, description="Specifies the total logical bytes transferred.", alias="logicalBytesTransferred")
    logical_size_bytes: Optional[StrictInt] = Field(default=None, description="Specifies the total logical size in bytes.", alias="logicalSizeBytes")
    physical_bytes_transferred: Optional[StrictInt] = Field(default=None, description="Specifies the total physical bytes transferred.", alias="physicalBytesTransferred")
    __properties: ClassVar[List[str]] = ["logicalBytesTransferred", "logicalSizeBytes", "physicalBytesTransferred"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReplicationDataStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if logical_bytes_transferred (nullable) is None
        # and model_fields_set contains the field
        if self.logical_bytes_transferred is None and "logical_bytes_transferred" in self.model_fields_set:
            _dict['logicalBytesTransferred'] = None

        # set to None if logical_size_bytes (nullable) is None
        # and model_fields_set contains the field
        if self.logical_size_bytes is None and "logical_size_bytes" in self.model_fields_set:
            _dict['logicalSizeBytes'] = None

        # set to None if physical_bytes_transferred (nullable) is None
        # and model_fields_set contains the field
        if self.physical_bytes_transferred is None and "physical_bytes_transferred" in self.model_fields_set:
            _dict['physicalBytesTransferred'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReplicationDataStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "logicalBytesTransferred": obj.get("logicalBytesTransferred"),
            "logicalSizeBytes": obj.get("logicalSizeBytes"),
            "physicalBytesTransferred": obj.get("physicalBytesTransferred")
        })
        return _obj


