# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.rigel_cluster_node import RigelClusterNode
from typing import Set
from typing_extensions import Self

class RigelClusterConfigParams(BaseModel):
    """
    Params for Rigel Cluster Creation
    """ # noqa: E501
    claim_token: Optional[StrictStr] = Field(default=None, description="Specifies the token which is used to claim this Cluster to Helios.", alias="claimToken")
    dataplane_endpoint: Optional[StrictStr] = Field(default=None, description="Specifies the endpoint of the dataplane cluster which is associated with this rigel.", alias="dataplaneEndpoint")
    nodes: Optional[List[RigelClusterNode]] = Field(default=None, description="Specifies the Nodes present in this Cluster.")
    __properties: ClassVar[List[str]] = ["claimToken", "dataplaneEndpoint", "nodes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RigelClusterConfigParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "claim_token",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in nodes (list)
        _items = []
        if self.nodes:
            for _item_nodes in self.nodes:
                if _item_nodes:
                    _items.append(_item_nodes.to_dict())
            _dict['nodes'] = _items
        # set to None if claim_token (nullable) is None
        # and model_fields_set contains the field
        if self.claim_token is None and "claim_token" in self.model_fields_set:
            _dict['claimToken'] = None

        # set to None if dataplane_endpoint (nullable) is None
        # and model_fields_set contains the field
        if self.dataplane_endpoint is None and "dataplane_endpoint" in self.model_fields_set:
            _dict['dataplaneEndpoint'] = None

        # set to None if nodes (nullable) is None
        # and model_fields_set contains the field
        if self.nodes is None and "nodes" in self.model_fields_set:
            _dict['nodes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RigelClusterConfigParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "claimToken": obj.get("claimToken"),
            "dataplaneEndpoint": obj.get("dataplaneEndpoint"),
            "nodes": [RigelClusterNode.from_dict(_item) for _item in obj["nodes"]] if obj.get("nodes") is not None else None
        })
        return _obj


