# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class S3AccountParams(BaseModel):
    """
    Specifies S3 Account parameters for User.
    """ # noqa: E501
    s3_access_key_id: Optional[StrictStr] = Field(default=None, description="Specifies the S3 Account Access Key ID.", alias="s3AccessKeyId")
    s3_account_id: Optional[StrictStr] = Field(default=None, description="Specifies the S3 Account Canonical User ID.", alias="s3AccountId")
    s3_secret_key: Optional[StrictStr] = Field(default=None, description="Specifies the S3 Account Secret Key.", alias="s3SecretKey")
    __properties: ClassVar[List[str]] = ["s3AccessKeyId", "s3AccountId", "s3SecretKey"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of S3AccountParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if s3_access_key_id (nullable) is None
        # and model_fields_set contains the field
        if self.s3_access_key_id is None and "s3_access_key_id" in self.model_fields_set:
            _dict['s3AccessKeyId'] = None

        # set to None if s3_account_id (nullable) is None
        # and model_fields_set contains the field
        if self.s3_account_id is None and "s3_account_id" in self.model_fields_set:
            _dict['s3AccountId'] = None

        # set to None if s3_secret_key (nullable) is None
        # and model_fields_set contains the field
        if self.s3_secret_key is None and "s3_secret_key" in self.model_fields_set:
            _dict['s3SecretKey'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of S3AccountParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "s3AccessKeyId": obj.get("s3AccessKeyId"),
            "s3AccountId": obj.get("s3AccountId"),
            "s3SecretKey": obj.get("s3SecretKey")
        })
        return _obj


