# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class SecurityPrincipal(BaseModel):
    """
    Specifies a security principal.
    """ # noqa: E501
    domain_name: Optional[StrictStr] = Field(default=None, description="Specifies the domain name where the security principal account is maintained.", alias="domainName")
    full_name: Optional[StrictStr] = Field(default=None, description="Specifies the full name (first and last name) of the security principal.", alias="fullName")
    object_class: Optional[StrictStr] = Field(default=None, description="Specifies the object class of the security principal.", alias="objectClass")
    principal_name: Optional[StrictStr] = Field(default=None, description="Specifies the name of the security principal.", alias="principalName")
    sid: Optional[StrictStr] = Field(default=None, description="Specifies the SID of the security principal.")
    __properties: ClassVar[List[str]] = ["domainName", "fullName", "objectClass", "principalName", "sid"]

    @field_validator('object_class')
    def object_class_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['User', 'Group', 'Computer', 'WellKnownPrincipal', 'ServiceAccount']):
            raise ValueError("must be one of enum values ('User', 'Group', 'Computer', 'WellKnownPrincipal', 'ServiceAccount')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SecurityPrincipal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if domain_name (nullable) is None
        # and model_fields_set contains the field
        if self.domain_name is None and "domain_name" in self.model_fields_set:
            _dict['domainName'] = None

        # set to None if full_name (nullable) is None
        # and model_fields_set contains the field
        if self.full_name is None and "full_name" in self.model_fields_set:
            _dict['fullName'] = None

        # set to None if object_class (nullable) is None
        # and model_fields_set contains the field
        if self.object_class is None and "object_class" in self.model_fields_set:
            _dict['objectClass'] = None

        # set to None if principal_name (nullable) is None
        # and model_fields_set contains the field
        if self.principal_name is None and "principal_name" in self.model_fields_set:
            _dict['principalName'] = None

        # set to None if sid (nullable) is None
        # and model_fields_set contains the field
        if self.sid is None and "sid" in self.model_fields_set:
            _dict['sid'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SecurityPrincipal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "domainName": obj.get("domainName"),
            "fullName": obj.get("fullName"),
            "objectClass": obj.get("objectClass"),
            "principalName": obj.get("principalName"),
            "sid": obj.get("sid")
        })
        return _obj


