# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.smb_active_open import SmbActiveOpen
from typing import Set
from typing_extensions import Self

class SmbActiveSession(BaseModel):
    """
    Specifies an active session and its file opens.
    """ # noqa: E501
    active_opens: Optional[List[SmbActiveOpen]] = Field(default=None, description="Specifies an active open of an SMB file, its access and sharing information.", alias="activeOpens")
    client_ip: Optional[StrictStr] = Field(default=None, description="Specifies the IP address from which the file is open.", alias="clientIp")
    domain: Optional[StrictStr] = Field(default=None, description="Specifies the domain of the user.")
    session_id: Optional[StrictInt] = Field(default=None, description="Specifies the id of the session.", alias="sessionId")
    user_name: Optional[StrictStr] = Field(default=None, description="Specifies the username who keeps the file open.", alias="userName")
    __properties: ClassVar[List[str]] = ["activeOpens", "clientIp", "domain", "sessionId", "userName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SmbActiveSession from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in active_opens (list)
        _items = []
        if self.active_opens:
            for _item_active_opens in self.active_opens:
                if _item_active_opens:
                    _items.append(_item_active_opens.to_dict())
            _dict['activeOpens'] = _items
        # set to None if active_opens (nullable) is None
        # and model_fields_set contains the field
        if self.active_opens is None and "active_opens" in self.model_fields_set:
            _dict['activeOpens'] = None

        # set to None if client_ip (nullable) is None
        # and model_fields_set contains the field
        if self.client_ip is None and "client_ip" in self.model_fields_set:
            _dict['clientIp'] = None

        # set to None if domain (nullable) is None
        # and model_fields_set contains the field
        if self.domain is None and "domain" in self.model_fields_set:
            _dict['domain'] = None

        # set to None if session_id (nullable) is None
        # and model_fields_set contains the field
        if self.session_id is None and "session_id" in self.model_fields_set:
            _dict['sessionId'] = None

        # set to None if user_name (nullable) is None
        # and model_fields_set contains the field
        if self.user_name is None and "user_name" in self.model_fields_set:
            _dict['userName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SmbActiveSession from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "activeOpens": [SmbActiveOpen.from_dict(_item) for _item in obj["activeOpens"]] if obj.get("activeOpens") is not None else None,
            "clientIp": obj.get("clientIp"),
            "domain": obj.get("domain"),
            "sessionId": obj.get("sessionId"),
            "userName": obj.get("userName")
        })
        return _obj


