# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class TaggingInfo(BaseModel):
    """
    Specifies the tagging config.
    """ # noqa: E501
    block_restore: Optional[StrictBool] = Field(default=None, description="Specifies if blocking restore operations from snapshots with specified tag is enabled or not.", alias="blockRestore")
    tag_id: Optional[StrictInt] = Field(default=None, description="Specifies the id of the tag used to identify which snapshots to block restore from.", alias="tagId")
    tag_name: Optional[StrictStr] = Field(default=None, description="Specifies the label of the tag used to identify which snapshots to block restore from.", alias="tagName")
    __properties: ClassVar[List[str]] = ["blockRestore", "tagId", "tagName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TaggingInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if block_restore (nullable) is None
        # and model_fields_set contains the field
        if self.block_restore is None and "block_restore" in self.model_fields_set:
            _dict['blockRestore'] = None

        # set to None if tag_id (nullable) is None
        # and model_fields_set contains the field
        if self.tag_id is None and "tag_id" in self.model_fields_set:
            _dict['tagId'] = None

        # set to None if tag_name (nullable) is None
        # and model_fields_set contains the field
        if self.tag_name is None and "tag_name" in self.model_fields_set:
            _dict['tagName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TaggingInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "blockRestore": obj.get("blockRestore"),
            "tagId": obj.get("tagId"),
            "tagName": obj.get("tagName")
        })
        return _obj


