# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class UpdateSupportUserParams(BaseModel):
    """
    Specifies the support user params.
    """ # noqa: E501
    current_password: Optional[StrictStr] = Field(default=None, description="Specifies the current password of the user. This is required when trying to update the current user's password.", alias="currentPassword")
    enable_sudo_access: Optional[StrictBool] = Field(default=None, description="If set to true, sudo access will be enabled for the user. If null, the endpoint will not attempt to alter sudo access privilege for the support user.", alias="enableSudoAccess")
    new_password: Optional[StrictStr] = Field(default=None, description="Specifies the new password for the support user.", alias="newPassword")
    __properties: ClassVar[List[str]] = ["currentPassword", "enableSudoAccess", "newPassword"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateSupportUserParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if current_password (nullable) is None
        # and model_fields_set contains the field
        if self.current_password is None and "current_password" in self.model_fields_set:
            _dict['currentPassword'] = None

        # set to None if enable_sudo_access (nullable) is None
        # and model_fields_set contains the field
        if self.enable_sudo_access is None and "enable_sudo_access" in self.model_fields_set:
            _dict['enableSudoAccess'] = None

        # set to None if new_password (nullable) is None
        # and model_fields_set contains the field
        if self.new_password is None and "new_password" in self.model_fields_set:
            _dict['newPassword'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateSupportUserParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "currentPassword": obj.get("currentPassword"),
            "enableSudoAccess": obj.get("enableSudoAccess"),
            "newPassword": obj.get("newPassword")
        })
        return _obj


