# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cohesity_sdk.helios.models.upgrade_check_test_result import UpgradeCheckTestResult
from typing import Set
from typing_extensions import Self

class UpgradeCheckNodeResult(BaseModel):
    """
    The healthcheck results for node
    """ # noqa: E501
    node_ip: Optional[StrictStr] = Field(default=None, description="The node ip", alias="nodeIp")
    node_test_results: Optional[List[UpgradeCheckTestResult]] = Field(default=None, description="The healthcheck test results for node", alias="nodeTestResults")
    node_test_status: Optional[StrictStr] = Field(default=None, description="The healthcheck run status for node", alias="nodeTestStatus")
    __properties: ClassVar[List[str]] = ["nodeIp", "nodeTestResults", "nodeTestStatus"]

    @field_validator('node_test_status')
    def node_test_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Running', 'Passed', 'Failed', 'Skipped', 'Error']):
            raise ValueError("must be one of enum values ('Running', 'Passed', 'Failed', 'Skipped', 'Error')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpgradeCheckNodeResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in node_test_results (list)
        _items = []
        if self.node_test_results:
            for _item_node_test_results in self.node_test_results:
                if _item_node_test_results:
                    _items.append(_item_node_test_results.to_dict())
            _dict['nodeTestResults'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpgradeCheckNodeResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "nodeIp": obj.get("nodeIp"),
            "nodeTestResults": [UpgradeCheckTestResult.from_dict(_item) for _item in obj["nodeTestResults"]] if obj.get("nodeTestResults") is not None else None,
            "nodeTestStatus": obj.get("nodeTestStatus")
        })
        return _obj


