# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class Vault(BaseModel):
    """
    Specifies the fields of vault.
    """ # noqa: E501
    global_vault_id: Optional[StrictStr] = Field(default=None, description="Specifies Global vault id.", alias="globalVaultId")
    region_id: Optional[StrictStr] = Field(default=None, description="Specifies id of region where vault resides.", alias="regionId")
    region_name: Optional[StrictStr] = Field(default=None, description="Specifies name of region where vault resides.", alias="regionName")
    vault_name: Optional[StrictStr] = Field(default=None, description="Specifies name of vault.", alias="vaultName")
    __properties: ClassVar[List[str]] = ["globalVaultId", "regionId", "regionName", "vaultName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Vault from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if global_vault_id (nullable) is None
        # and model_fields_set contains the field
        if self.global_vault_id is None and "global_vault_id" in self.model_fields_set:
            _dict['globalVaultId'] = None

        # set to None if region_id (nullable) is None
        # and model_fields_set contains the field
        if self.region_id is None and "region_id" in self.model_fields_set:
            _dict['regionId'] = None

        # set to None if region_name (nullable) is None
        # and model_fields_set contains the field
        if self.region_name is None and "region_name" in self.model_fields_set:
            _dict['regionName'] = None

        # set to None if vault_name (nullable) is None
        # and model_fields_set contains the field
        if self.vault_name is None and "vault_name" in self.model_fields_set:
            _dict['vaultName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Vault from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "globalVaultId": obj.get("globalVaultId"),
            "regionId": obj.get("regionId"),
            "regionName": obj.get("regionName"),
            "vaultName": obj.get("vaultName")
        })
        return _obj


