# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class ViewPinningConfig(BaseModel):
    """
    Specifies the pinning config of a view.
    """ # noqa: E501
    enabled: Optional[StrictBool] = Field(description="Specifies if view pinning is enabled. If set to true, view will be pinned to SSD and view data will be stored there.")
    last_updated_timestamp_secs: Optional[StrictInt] = Field(default=None, description="Specifies the timestamp when view pinning config is last updated.", alias="lastUpdatedTimestampSecs")
    pinned_time_secs: Optional[StrictInt] = Field(default=None, description="Specifies the time to pin files after last access.", alias="pinnedTimeSecs")
    __properties: ClassVar[List[str]] = ["enabled", "lastUpdatedTimestampSecs", "pinnedTimeSecs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ViewPinningConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "last_updated_timestamp_secs",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if enabled (nullable) is None
        # and model_fields_set contains the field
        if self.enabled is None and "enabled" in self.model_fields_set:
            _dict['enabled'] = None

        # set to None if last_updated_timestamp_secs (nullable) is None
        # and model_fields_set contains the field
        if self.last_updated_timestamp_secs is None and "last_updated_timestamp_secs" in self.model_fields_set:
            _dict['lastUpdatedTimestampSecs'] = None

        # set to None if pinned_time_secs (nullable) is None
        # and model_fields_set contains the field
        if self.pinned_time_secs is None and "pinned_time_secs" in self.model_fields_set:
            _dict['pinnedTimeSecs'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ViewPinningConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enabled": obj.get("enabled"),
            "lastUpdatedTimestampSecs": obj.get("lastUpdatedTimestampSecs"),
            "pinnedTimeSecs": obj.get("pinnedTimeSecs")
        })
        return _obj


