# coding: utf-8

"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self

class WorkflowInterventionSpec(BaseModel):
    """
    Specifies the intervention for each workflow type.
    """ # noqa: E501
    intervention: Optional[StrictStr] = Field(description="Specifies the intervention type for ongoing tasks.")
    workflow_type: Optional[StrictStr] = Field(description="Specifies the workflow type for which an intervention would be needed when maintenance mode begins", alias="workflowType")
    __properties: ClassVar[List[str]] = ["intervention", "workflowType"]

    @field_validator('intervention')
    def intervention_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NoIntervention', 'Cancel']):
            raise ValueError("must be one of enum values ('NoIntervention', 'Cancel')")
        return value

    @field_validator('workflow_type')
    def workflow_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['BackupRun']):
            raise ValueError("must be one of enum values ('BackupRun')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkflowInterventionSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if intervention (nullable) is None
        # and model_fields_set contains the field
        if self.intervention is None and "intervention" in self.model_fields_set:
            _dict['intervention'] = None

        # set to None if workflow_type (nullable) is None
        # and model_fields_set contains the field
        if self.workflow_type is None and "workflow_type" in self.model_fields_set:
            _dict['workflowType'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkflowInterventionSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "intervention": obj.get("intervention"),
            "workflowType": obj.get("workflowType")
        })
        return _obj


